searchNodes=[{"doc":"Formats numbers and currencies based upon CLDR's decimal formats specification. The format specification is documentated in Unicode TR35 . There are several classes of formatting including non-scientific, scientific, rules based (for spelling and ordinal formats), compact formats that display 1k rather than 1,000 and so on. See Cldr.Number.to_string/2 for specific formatting options. Non-Scientific Notation Formatting The following description applies to formats that do not use scientific notation or significant digits: If the number of actual integer digits exceeds the maximum integer digits, then only the least significant digits are shown. For example, 1997 is formatted as &quot;97&quot; if the maximum integer digits is set to 2. If the number of actual integer digits is less than the minimum integer digits, then leading zeros are added. For example, 1997 is formatted as &quot;01997&quot; if the minimum integer digits is set to 5. If the number of actual fraction digits exceeds the maximum fraction digits, then half-even rounding it performed to the maximum fraction digits. For example, 0.125 is formatted as &quot;0.12&quot; if the maximum fraction digits is 2. This behavior can be changed by specifying a rounding increment and a rounding mode. If the number of actual fraction digits is less than the minimum fraction digits, then trailing zeros are added. For example, 0.125 is formatted as &quot;0.1250&quot; if the minimum fraction digits is set to 4. Trailing fractional zeros are not displayed if they occur j positions after the decimal, where j is less than the maximum fraction digits. For example, 0.10004 is formatted as &quot;0.1&quot; if the maximum fraction digits is four or less. Scientific Notation Formatting Numbers in scientific notation are expressed as the product of a mantissa and a power of ten, for example, 1234 can be expressed as 1.234 x 10^3. The mantissa is typically in the half-open interval [1.0, 10.0) or sometimes [0.0, 1.0), but it need not be. In a pattern, the exponent character immediately followed by one or more digit characters indicates scientific notation. Example: &quot;0.###E0&quot; formats the number 1234 as &quot;1.234E3&quot;. The number of digit characters after the exponent character gives the minimum exponent digit count. There is no maximum. Negative exponents are formatted using the localized minus sign, not the prefix and suffix from the pattern. This allows patterns such as &quot;0.###E0 m/s&quot;. To prefix positive exponents with a localized plus sign, specify '+' between the exponent and the digits: &quot;0.###E+0&quot; will produce formats &quot;1E+1&quot;, &quot;1E+0&quot;, &quot;1E-1&quot;, and so on. (In localized patterns, use the localized plus sign rather than '+'.) The minimum number of integer digits is achieved by adjusting the exponent. Example: 0.00123 formatted with &quot;00.###E0&quot; yields &quot;12.3E-4&quot;. This only happens if there is no maximum number of integer digits. If there is a maximum, then the minimum number of integer digits is fixed at one. The maximum number of integer digits, if present, specifies the exponent grouping. The most common use of this is to generate engineering notation, in which the exponent is a multiple of three, for example, &quot;##0.###E0&quot;. The number 12345 is formatted using &quot;##0.####E0&quot; as &quot;12.345E3&quot;. When using scientific notation, the formatter controls the digit counts using significant digits logic. The maximum number of significant digits limits the total number of integer and fraction digits that will be shown in the mantissa; it does not affect parsing. For example, 12345 formatted with &quot;##0.##E0&quot; is &quot;12.3E3&quot;. Exponential patterns may not contain grouping separators. Significant Digits There are two ways of controlling how many digits are shows: (a) significant digits counts, or (b) integer and fraction digit counts. Integer and fraction digit counts are described above. When a formatter is using significant digits counts, it uses however many integer and fraction digits are required to display the specified number of significant digits. It may ignore min/max integer/fraction digits, or it may use them to the extent possible.","ref":"Cldr.Number.html","title":"Cldr.Number","type":"module"},{"doc":"Return the precision (number of digits) of a number This function delegates to Cldr.Digits.number_of_digits/1 Example iex&gt; Cldr.Number . precision 1.234 4","ref":"Cldr.Number.html#precision/1","title":"Cldr.Number.precision/1","type":"function"},{"doc":"Formats a number and applies the :approximately format for a locale and number system. Arguments number is an integer, float or Decimal to be formatted backend is any Cldr backend. That is, any module that contains use Cldr options is a keyword list defining how the number is to be formatted. See Cldr.Number.to_string/3 for a description of the available options. Example iex&gt; Cldr.Number . to_approx_string 1234 , TestBackend.Cldr { :ok , &quot;~1,234&quot; }","ref":"Cldr.Number.html#to_approx_string/3","title":"Cldr.Number.to_approx_string/3","type":"function"},{"doc":"Formats a number and applies the :at_least format for a locale and number system. Arguments number is an integer, float or Decimal to be formatted backend is any Cldr backend. That is, any module that contains use Cldr options is a keyword list defining how the number is to be formatted. See Cldr.Number.to_string/3 for a description of the available options. Example iex&gt; Cldr.Number . to_at_least_string 1234 , TestBackend.Cldr { :ok , &quot;1,234+&quot; }","ref":"Cldr.Number.html#to_at_least_string/3","title":"Cldr.Number.to_at_least_string/3","type":"function"},{"doc":"Formats a number and applies the :at_most format for a locale and number system. Arguments number is an integer, float or Decimal to be formatted backend is any Cldr backend. That is, any module that contains use Cldr options is a keyword list defining how the number is to be formatted. See Cldr.Number.to_string/3 for a description of the available options. Example iex&gt; Cldr.Number . to_at_most_string 1234 , TestBackend.Cldr { :ok , &quot;≤1,234&quot; }","ref":"Cldr.Number.html#to_at_most_string/3","title":"Cldr.Number.to_at_most_string/3","type":"function"},{"doc":"Converts a number from the latin digits 0..9 into another number system. Returns {:ok, string} or {:error, reason} . number is an integer, float. Decimal is supported only for :numeric number systems, not :algorithmic . See Cldr.Number.System.to_system/3 for further information. system is any number system returned by Cldr.known_number_systems/0 Examples iex&gt; Cldr.Number . to_number_system 123 , :hant , TestBackend.Cldr { :ok , &quot;一百二十三&quot; } iex&gt; Cldr.Number . to_number_system 123 , :hebr , TestBackend.Cldr { :ok , &quot;קכ״ג&quot; }","ref":"Cldr.Number.html#to_number_system/3","title":"Cldr.Number.to_number_system/3","type":"function"},{"doc":"Converts a number from the latin digits 0..9 into another number system. Returns the converted number or raises an exception on error. number is an integer, float. Decimal is supported only for :numeric number systems, not :algorithmic . See Cldr.Number.System.to_system/3 for further information. system is any number system returned by Cldr.Number.System.known_number_systems/0 Example iex&gt; Cldr.Number . to_number_system! 123 , :hant , TestBackend.Cldr &quot;一百二十三&quot;","ref":"Cldr.Number.html#to_number_system!/3","title":"Cldr.Number.to_number_system!/3","type":"function"},{"doc":"Formats the first and last numbers of a range and applies the :range format for a locale and number system. Arguments number is an integer, float or Decimal to be formatted backend is any Cldr backend. That is, any module that contains use Cldr options is a keyword list defining how the number is to be formatted. See Cldr.Number.to_string/3 for a description of the available options. Example iex&gt; Cldr.Number . to_range_string 1234 .. 5678 , TestBackend.Cldr { :ok , &quot;1,234–5,678&quot; }","ref":"Cldr.Number.html#to_range_string/3","title":"Cldr.Number.to_range_string/3","type":"function"},{"doc":"Returns a number formatted into a string according to a format pattern and options. Arguments number is an integer, float or Decimal to be formatted backend is any Cldr backend. That is, any module that contains use Cldr options is a keyword list defining how the number is to be formatted. The valid options are: Options format : the format style or a format string defining how the number is formatted. See Cldr.Number.Format for how format strings can be constructed. See Cldr.Number.Format.format_styles_for/3 to return available format styles for a locale. The default format is :standard . If :format is set to :long or :short then the formatting depends on whether :currency is specified. If not specified then the number is formatted as :decimal_long or :decimal_short . If :currency is specified the number is formatted as :currency_long or :currency_short and :fractional_digits is set to 0 as a default. :format may also be a format defined by CLDR's Rules Based Number Formats (RBNF). Further information is found in the module Cldr.Rbnf . The most commonly used formats in this category are to spell out the number in a the locales language. The applicable formats are :spellout , :spellout_year , :ordinal . A number can also be formatted as roman numbers by using the format :roman or :roman_lower . currency : is the currency for which the number is formatted. For available currencies see Cldr.Currency.known_currencies/0 . This option is required if :format is set to :currency . If currency is set and no :format is set, :format will be set to :currency as well. currency_symbol : Allows overriding a currency symbol. The alternatives are: :iso the ISO currency code will be used instead of the default currency symbol. :narrow uses the narrow symbol defined for the locale. The same narrow symbol can be defined for more than one currency and therefore this should be used with care. If no narrow symbol is defined, the standard symbol is used. :symbol uses the standard symbol defined in CLDR. A symbol is unique for each currency and can be safely used. &quot;string&quot; uses string as the currency symbol :standard (the default and recommended) uses the CLDR-defined symbol based upon the currency format for the locale. :cash : a boolean which indicates whether a number being formatted as a :currency is to be considered a cash value or not. Currencies can be rounded differently depending on whether :cash is true or false . *This option is deprecated in favour of currency_digits: :cash . :currency_digits indicates which of the rounding and digits should be used. The options are :accounting which is the default, :cash or :iso :rounding_mode : determines how a number is rounded to meet the precision of the format requested. The available rounding modes are :down , :half_up, :half_even, :ceiling, :floor, :half_down, :up. The default is :half_even . :number_system : determines which of the number systems for a locale should be used to define the separators and digits for the formatted number. If number_system is an atom then number_system is interpreted as a number system. See Cldr.Number.System.number_systems_for/2 . If the :number_system is binary then it is interpreted as a number system name. See Cldr.Number.System.number_system_names_for/2 . The default is :default . :locale : determines the locale in which the number is formatted. See Cldr.known_locale_names/0 . The default is Cldr.get_locale/0 which is the locale currently in affect for this Process and which is set by Cldr.put_locale/1 . If :fractional_digits is set to a positive integer value then the number will be rounded to that number of digits and displayed accordingly - overriding settings that would be applied by default. For example, currencies have fractional digits defined reflecting each currencies minor unit. Setting :fractional_digits will override that setting. If :maximum_integer_digits is set to a positive integer value then the numnber is left truncated before formatting. For example if the number 1234 is formatted with the option maximum_integer_digits: 2 , the number is truncated to 34 and formatted. If :round_nearest is set to a positive integer value then the number will be rounded to nearest increment of that value - overriding settings that would be applied by default. :minimum_grouping_digits overrides the CLDR definition of minimum grouping digits. For example in the locale es the number 1234 is formatted by default as 1345 because the locale defines the minimium_grouping_digits as 2 . If minimum_grouping_digits: 1 is set as an option the number is formatting as 1.345 . The :minimum_grouping_digits is added to the grouping defined by the number format. If the sum of these two digits is greater than the number of digits in the integer (or fractional) part of the number then no grouping is performed. Locale extensions affecting formatting A locale identifier can specify options that affect number formatting. These options are: cu : defines what currency is implied when no curreny is specified in the call to to_string/2 . cf : defines whether to use currency or accounting format for formatting currencies. This overrides the format: :currency and format: :accounting options. nu : defines the number system to be used if none is specified by the :number_system option to to_string/2 These keys are part of the u extension and that document should be consulted for details on how to construct a locale identifier with these extensions. Returns {:ok, string} or {:error, {exception, message}} Examples iex&gt; Cldr.Number . to_string 12345 , TestBackend.Cldr { :ok , &quot;12,345&quot; } iex&gt; Cldr.Number . to_string 12345 , TestBackend.Cldr , locale : &quot;fr&quot; { :ok , &quot;12 345&quot; } iex&gt; Cldr.Number . to_string 1345.32 , TestBackend.Cldr , currency : :EUR , locale : &quot;es&quot; , minimum_grouping_digits : 1 { :ok , &quot;1.345,32 €&quot; } iex&gt; Cldr.Number . to_string 1345.32 , TestBackend.Cldr , currency : :EUR , locale : &quot;es&quot; { :ok , &quot;1345,32 €&quot; } iex&gt; Cldr.Number . to_string 12345 , TestBackend.Cldr , locale : &quot;fr&quot; , currency : &quot;USD&quot; { :ok , &quot;12 345,00 $US&quot; } iex&gt; Cldr.Number . to_string 12345 , TestBackend.Cldr , format : &quot;#E0&quot; { :ok , &quot;1.2345E4&quot; } iex&gt; Cldr.Number . to_string 12345 , TestBackend.Cldr , format : :accounting , currency : &quot;THB&quot; { :ok , &quot;THB 12,345.00&quot; } iex&gt; Cldr.Number . to_string - 12345 , TestBackend.Cldr , format : :accounting , currency : &quot;THB&quot; { :ok , &quot;(THB 12,345.00)&quot; } iex&gt; Cldr.Number . to_string 12345 , TestBackend.Cldr , format : :accounting , currency : &quot;THB&quot; , ...&gt; locale : &quot;th&quot; { :ok , &quot;฿12,345.00&quot; } iex&gt; Cldr.Number . to_string 12345 , TestBackend.Cldr , format : :accounting , currency : &quot;THB&quot; , ...&gt; locale : &quot;th&quot; , number_system : :native { :ok , &quot;฿๑๒,๓๔๕.๐๐&quot; } iex&gt; Cldr.Number . to_string 1244.30 , TestBackend.Cldr , format : :long { :ok , &quot;1 thousand&quot; } iex&gt; Cldr.Number . to_string 1244.30 , TestBackend.Cldr , format : :long , currency : &quot;USD&quot; { :ok , &quot;1,244 US dollars&quot; } iex&gt; Cldr.Number . to_string 1244.30 , TestBackend.Cldr , format : :short { :ok , &quot;1K&quot; } iex&gt; Cldr.Number . to_string 1244.30 , TestBackend.Cldr , format : :short , currency : &quot;EUR&quot; { :ok , &quot;€1K&quot; } iex&gt; Cldr.Number . to_string 1234 , TestBackend.Cldr , format : :spellout { :ok , &quot;one thousand two hundred thirty-four&quot; } iex&gt; Cldr.Number . to_string 1234 , TestBackend.Cldr , format : :spellout_verbose { :ok , &quot;one thousand two hundred and thirty-four&quot; } iex&gt; Cldr.Number . to_string 1989 , TestBackend.Cldr , format : :spellout_year { :ok , &quot;nineteen eighty-nine&quot; } iex&gt; Cldr.Number . to_string 123 , TestBackend.Cldr , format : :ordinal { :ok , &quot;123rd&quot; } iex&gt; Cldr.Number . to_string 123 , TestBackend.Cldr , format : :roman { :ok , &quot;CXXIII&quot; } iex&gt; Cldr.Number . to_string 123 , TestBackend.Cldr , locale : &quot;th-u-nu-thai&quot; { :ok , &quot;๑๒๓&quot; } iex&gt; Cldr.Number . to_string 123 , TestBackend.Cldr , format : :currency , locale : &quot;en-u-cu-thb&quot; { :ok , &quot;THB 123.00&quot; } Errors An error tuple {:error, reason} will be returned if an error is detected. The two most likely causes of an error return are: A format cannot be compiled. In this case the error tuple will look like: iex&gt; Cldr.Number . to_string ( 12345 , TestBackend.Cldr , format : &quot;0#&quot; ) { :error , { Cldr.FormatCompileError , &quot;Decimal format compiler: syntax error before: \\&quot; # \\&quot; &quot; } } The format style requested is not defined for the locale and number_system . This happens typically when the number system is :algorithmic rather than the more common :numeric . In this case the error return looks like: iex&gt; Cldr.Number . to_string ( 1234 , TestBackend.Cldr , locale : &quot;he&quot; , number_system : &quot;hebr&quot; ) { :error , { Cldr.UnknownFormatError , &quot;The locale \\&quot; he \\&quot; with number system :hebr does not define a format :standard&quot; } }","ref":"Cldr.Number.html#to_string/3","title":"Cldr.Number.to_string/3","type":"function"},{"doc":"Same as the execution of to_string/2 but raises an exception if an error would be returned. Options number is an integer, float or Decimal to be formatted options is a keyword list defining how the number is to be formatted. See Cldr.Number.to_string/2 Returns a formatted number as a string or raises an exception Examples iex&gt; Cldr.Number . to_string! 12345 , TestBackend.Cldr &quot;12,345&quot; iex&gt; Cldr.Number . to_string! 12345 , TestBackend.Cldr , locale : &quot;fr&quot; &quot;12 345&quot;","ref":"Cldr.Number.html#to_string!/3","title":"Cldr.Number.to_string!/3","type":"function"},{"doc":"Return a valid number system from a provided locale and number system name or type. The number system or number system type must be valid for the given locale. If a number system type is provided, the underlying number system is returned. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 system_name is any number system name returned by Cldr.known_number_systems/0 or a number system type returned by Cldr.known_number_system_types/0 backend is any module that includes use Cldr and therefore is a Cldr backend module Examples iex&gt; Cldr.Number . validate_number_system &quot;en&quot; , :latn , TestBackend.Cldr { :ok , :latn } iex&gt; Cldr.Number . validate_number_system &quot;en&quot; , :default , TestBackend.Cldr { :ok , :latn } iex&gt; Cldr.Number . validate_number_system &quot;en&quot; , :unknown , TestBackend.Cldr { :error , { Cldr.UnknownNumberSystemError , &quot;The number system :unknown is unknown&quot; } } iex&gt; Cldr.Number . validate_number_system &quot;zz&quot; , :default , TestBackend.Cldr { :error , { Cldr.InvalidLanguageError , &quot;The language \\&quot; zz \\&quot; is invalid&quot; } }","ref":"Cldr.Number.html#validate_number_system/3","title":"Cldr.Number.validate_number_system/3","type":"function"},{"doc":"","ref":"Cldr.Number.html#t:format_type/0","title":"Cldr.Number.format_type/0","type":"type"},{"doc":"Functions to manage the collection of number patterns defined in Cldr. Number patterns affect how numbers are interpreted in a localized context. Here are some examples, based on the French locale. The &quot;.&quot; shows where the decimal point should go. The &quot;,&quot; shows where the thousands separator should go. A &quot;0&quot; indicates zero-padding: if the number is too short, a zero (in the locale's numeric set) will go there. A &quot;#&quot; indicates no padding: if the number is too short, nothing goes there. A &quot;¤&quot; shows where the currency sign will go. The following illustrates the effects of different patterns for the French locale, with the number &quot;1234.567&quot;. Notice how the pattern characters ',' and '.' are replaced by the characters appropriate for the locale. Number Pattern Examples Pattern Currency Text #,##0.## n/a 1 234,57 #,##0.### n/a 1 234,567 ###0.##### n/a 1234,567 ###0.0000# n/a 1234,5670 00000.0000 n/a 01234,5670 #,##0.00 ¤ EUR 1 234,57 € The number of # placeholder characters before the decimal do not matter, since no limit is placed on the maximum number of digits. There should, however, be at least one zero some place in the pattern. In currency formats, the number of digits after the decimal also do not matter, since the information in the supplemental data (see Supplemental Currency Data) is used to override the number of decimal places — and the rounding — according to the currency that is being formatted. That can be seen in the above chart, with the difference between Yen and Euro formatting. Details of the number formats are described in the Unicode documentation","ref":"Cldr.Number.Format.html","title":"Cldr.Number.Format","type":"module"},{"doc":"Returns the decimal formats defined for a given locale. Options locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 backend is any Cldr backend. That is, any module that contains use Cldr Examples Cldr.Number.Format . all_formats_for ( &quot;en&quot; , MyApp.Cldr ) #=&gt; {:ok, %{latn: %Cldr.Number.Format{ accounting : &quot;¤#,##0.00;(¤#,##0.00)&quot; , currency : &quot;¤#,##0.00&quot; , percent : &quot;#,##0%&quot; , scientific : &quot;#E0&quot; , standard : &quot;#,##0.###&quot; , currency_short : [ { &quot;1000&quot; , [ one : &quot;¤0K&quot; , other : &quot;¤0K&quot; ] } , { &quot;10000&quot; , [ one : &quot;¤00K&quot; , other : &quot;¤00K&quot; ] } , { &quot;100000&quot; , [ one : &quot;¤000K&quot; , other : &quot;¤000K&quot; ] } , { &quot;1000000&quot; , [ one : &quot;¤0M&quot; , other : &quot;¤0M&quot; ] } , { &quot;10000000&quot; , [ one : &quot;¤00M&quot; , other : &quot;¤00M&quot; ] } , { &quot;100000000&quot; , [ one : &quot;¤000M&quot; , other : &quot;¤000M&quot; ] } , { &quot;1000000000&quot; , [ one : &quot;¤0B&quot; , other : &quot;¤0B&quot; ] } , { &quot;10000000000&quot; , [ one : &quot;¤00B&quot; , other : &quot;¤00B&quot; ] } , { &quot;100000000000&quot; , [ one : &quot;¤000B&quot; , other : &quot;¤000B&quot; ] } , { &quot;1000000000000&quot; , [ one : &quot;¤0T&quot; , other : &quot;¤0T&quot; ] } , { &quot;10000000000000&quot; , [ one : &quot;¤00T&quot; , other : &quot;¤00T&quot; ] } , { &quot;100000000000000&quot; , [ one : &quot;¤000T&quot; , other : &quot;¤000T&quot; ] } ] , ... . } }","ref":"Cldr.Number.Format.html#all_formats_for/2","title":"Cldr.Number.Format.all_formats_for/2","type":"function"},{"doc":"Returns the decimal formats defined for a given locale. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 backend is any Cldr backend. That is, any module that contains use Cldr Returns a list of decimal formats ot raises an exception See Cldr.Number.Format.all_formats_for/2 for further information.","ref":"Cldr.Number.Format.html#all_formats_for!/2","title":"Cldr.Number.Format.all_formats_for!/2","type":"function"},{"doc":"Returns the currency space for a given locale and number system. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 number_system is any valid number system or number system type returned by Cldr.Number.System.number_systems_for/2 backend is any Cldr backend. That is, any module that contains use Cldr","ref":"Cldr.Number.Format.html#currency_spacing/3","title":"Cldr.Number.Format.currency_spacing/3","type":"function"},{"doc":"Returns the list of decimal formats in the configured locales including the list of locales configured for precompilation in config.exs . This function exists to allow the decimal formatter to precompile all the known formats at compile time. Arguments backend is any Cldr backend. That is, any module that contains use Cldr Example =&gt; Cldr.Number.Format . decimal_format_list ( MyApp.Cldr ) [ &quot;#&quot; , &quot;#,##,##0%&quot; , &quot;#,##,##0.###&quot; , &quot;#,##,##0.00¤&quot; , &quot;#,##,##0.00¤;(#,##,##0.00¤)&quot; , &quot;#,##,##0 %&quot; , &quot;#,##0%&quot; , &quot;#,##0.###&quot; , &quot;#,##0.00 ¤&quot; , &quot;#,##0.00 ¤;(#,##0.00 ¤)&quot; , &quot;#,##0.00¤&quot; , &quot;#,##0.00¤;(#,##0.00¤)&quot; , &quot;#,##0 %&quot; , &quot;#0%&quot; , &quot;#0.######&quot; , &quot;#0.00 ¤&quot; , &quot;#E0&quot; , &quot;%#,##0&quot; , &quot;% #,##0&quot; , &quot;0&quot; , &quot;0.000000E+000&quot; , &quot;0000 M ¤&quot; , &quot;0000¤&quot; , &quot;000G ¤&quot; , &quot;000K ¤&quot; , &quot;000M ¤&quot; , &quot;000T ¤&quot; , &quot;000mM ¤&quot; , &quot;000m ¤&quot; , &quot;000 Bio&#39;.&#39; ¤&quot; , &quot;000 Bln ¤&quot; , &quot;000 Bn ¤&quot; , &quot;000 B ¤&quot; , &quot;000 E ¤&quot; , &quot;000 K ¤&quot; , &quot;000 MRD ¤&quot; , &quot;000 Md ¤&quot; , &quot;000 Mio&#39;.&#39; ¤&quot; , &quot;000 Mio ¤&quot; , &quot;000 Mld ¤&quot; , &quot;000 Mln ¤&quot; , &quot;000 Mn ¤&quot; , &quot;000 Mrd&#39;.&#39; ¤&quot; , &quot;000 Mrd ¤&quot; , &quot;000 Mr ¤&quot; , &quot;000 M ¤&quot; , &quot;000 NT ¤&quot; , &quot;000 N ¤&quot; , &quot;000 Tn ¤&quot; , &quot;000 Tr ¤&quot; , ... ]","ref":"Cldr.Number.Format.html#decimal_format_list/1","title":"Cldr.Number.Format.decimal_format_list/1","type":"function"},{"doc":"Returns the list of decimal formats for a configured locale. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 backend is any Cldr backend. That is, any module that contains use Cldr This function exists to allow the decimal formatter to precompile all the known formats at compile time. Its use is not otherwise recommended. Example iex&gt; Cldr.Number.Format . decimal_format_list_for ( &quot;en&quot; , MyApp.Cldr ) { :ok , [ &quot;#,##0%&quot; , &quot;#,##0.###&quot; , &quot;#E0&quot; , &quot;0 billion&quot; , &quot;0 million&quot; , &quot;0 thousand&quot; , &quot;0 trillion&quot; , &quot;00 billion&quot; , &quot;00 million&quot; , &quot;00 thousand&quot; , &quot;00 trillion&quot; , &quot;000 billion&quot; , &quot;000 million&quot; , &quot;000 thousand&quot; , &quot;000 trillion&quot; , &quot;000B&quot; , &quot;000K&quot; , &quot;000M&quot; , &quot;000T&quot; , &quot;00B&quot; , &quot;00K&quot; , &quot;00M&quot; , &quot;00T&quot; , &quot;0B&quot; , &quot;0K&quot; , &quot;0M&quot; , &quot;0T&quot; , &quot;¤#,##0.00&quot; , &quot;¤#,##0.00;(¤#,##0.00)&quot; , &quot;¤000B&quot; , &quot;¤000K&quot; , &quot;¤000M&quot; , &quot;¤000T&quot; , &quot;¤00B&quot; , &quot;¤00K&quot; , &quot;¤00M&quot; , &quot;¤00T&quot; , &quot;¤0B&quot; , &quot;¤0K&quot; , &quot;¤0M&quot; , &quot;¤0T&quot; ] }","ref":"Cldr.Number.Format.html#decimal_format_list_for/2","title":"Cldr.Number.Format.decimal_format_list_for/2","type":"function"},{"doc":"Returns the decimal format styles that are supported by Cldr.Number.Formatter.Decimal . Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 number_system is any valid number system or number system type returned by Cldr.Number.System.number_systems_for/2 backend is any Cldr backend. That is, any module that contains use Cldr Example iex&gt; Cldr.Number.Format . decimal_format_styles_for ( &quot;en&quot; , :latn , MyApp.Cldr ) { :ok , [ :accounting , :currency , :currency_long , :percent , :scientific , :standard ] }","ref":"Cldr.Number.Format.html#decimal_format_styles_for/3","title":"Cldr.Number.Format.decimal_format_styles_for/3","type":"function"},{"doc":"Returns the default grouping for a locale. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/0 backend is any Cldr backend. That is, any module that contains use Cldr Returns {:ok, minumum_digits} or {:error, {exception, message}} Examples iex&gt; Cldr.Number.Format . default_grouping_for ( &quot;en&quot; , MyApp.Cldr ) { :ok , %{ fraction : %{ first : 0 , rest : 0 } , integer : %{ first : 3 , rest : 3 } } }","ref":"Cldr.Number.Format.html#default_grouping_for/2","title":"Cldr.Number.Format.default_grouping_for/2","type":"function"},{"doc":"Returns the default grouping for a locale or raises if there is an error. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 backend is any Cldr backend. That is, any module that contains use Cldr Examples iex&gt; Cldr.Number.Format . default_grouping_for! ( &quot;en&quot; , MyApp.Cldr ) %{ fraction : %{ first : 0 , rest : 0 } , integer : %{ first : 3 , rest : 3 } } Cldr.Number.Format . default_grouping_for! ( :invalid ) ** (Cldr.UnknownLocaleError) The locale :invalid is invalid","ref":"Cldr.Number.Format.html#default_grouping_for!/2","title":"Cldr.Number.Format.default_grouping_for!/2","type":"function"},{"doc":"Returns the format styles available for a locale . Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 number_system is any valid number system or number system type returned by Cldr.Number.System.number_systems_for/2 backend is any Cldr backend. That is, any module that contains use Cldr Format styles standardise the access to a format defined for a common use. These types are :standard , :currency , :accounting , :scientific and :percent, :currency_short, :decimal_short, :decimal_long. These types can be used when formatting a number for output. For example Cldr.Number.to_string(123.456, format: :percent) . Example iex&gt; Cldr.Number.Format . format_styles_for ( &quot;en&quot; , :latn , MyApp.Cldr ) { :ok , [ :accounting , :currency , :currency_long , :currency_short , :decimal_long , :decimal_short , :percent , :scientific , :standard ] }","ref":"Cldr.Number.Format.html#format_styles_for/3","title":"Cldr.Number.Format.format_styles_for/3","type":"function"},{"doc":"Returns the names of the number systems for the locale . Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 backend is any Cldr backend. That is, any module that contains use Cldr Examples iex&gt; Cldr.Number.Format . format_system_names_for ( &quot;th&quot; , MyApp.Cldr ) { :ok , [ :latn , :thai ] } iex&gt; Cldr.Number.Format . format_system_names_for ( &quot;pl&quot; , MyApp.Cldr ) { :ok , [ :latn ] }","ref":"Cldr.Number.Format.html#format_system_names_for/2","title":"Cldr.Number.Format.format_system_names_for/2","type":"function"},{"doc":"Returns the number system types available for a locale Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 backend is any Cldr backend. That is, any module that contains use Cldr A number system type is an identifier that categorises number systems that comprise a site of digits or rules for transliterating or translating digits and a number system name for determining plural rules and format masks. If that all sounds a bit complicated then the default number system type called :default is probably what you want nearly all the time. Examples iex&gt; Cldr.Number.Format . format_system_types_for ( &quot;pl&quot; , MyApp.Cldr ) { :ok , [ :default , :native ] } iex&gt; Cldr.Number.Format . format_system_types_for ( &quot;ru&quot; , MyApp.Cldr ) { :ok , [ :default , :native ] } iex&gt; Cldr.Number.Format . format_system_types_for ( &quot;th&quot; , MyApp.Cldr ) { :ok , [ :default , :native ] }","ref":"Cldr.Number.Format.html#format_system_types_for/2","title":"Cldr.Number.Format.format_system_types_for/2","type":"function"},{"doc":"Return the predfined formats for a given locale and number_system . Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 number_system is any valid number system or number system type returned by Cldr.Number.System.number_systems_for/2 or Cldr.Number.System.number_system_names_for/2 backend is any Cldr backend. That is, any module that contains use Cldr Example Cldr.Number.Format . formats_for &quot;fr&quot; , :native , MyApp.Cldr #=&gt; {:ok, %Cldr.Number.Format{ accounting : &quot;#,##0.00 ¤;(#,##0.00 ¤)&quot; , currency : &quot;#,##0.00 ¤&quot; , percent : &quot;#,##0 %&quot; , scientific : &quot;#E0&quot; , standard : &quot;#,##0.###&quot; currency_short : [ { &quot;1000&quot; , [ one : &quot;0 k ¤&quot; , other : &quot;0 k ¤&quot; ] } , { &quot;10000&quot; , [ one : &quot;00 k ¤&quot; , other : &quot;00 k ¤&quot; ] } , { &quot;100000&quot; , [ one : &quot;000 k ¤&quot; , other : &quot;000 k ¤&quot; ] } , { &quot;1000000&quot; , [ one : &quot;0 M ¤&quot; , other : &quot;0 M ¤&quot; ] } , { &quot;10000000&quot; , [ one : &quot;00 M ¤&quot; , other : &quot;00 M ¤&quot; ] } , { &quot;100000000&quot; , [ one : &quot;000 M ¤&quot; , other : &quot;000 M ¤&quot; ] } , { &quot;1000000000&quot; , [ one : &quot;0 Md ¤&quot; , other : &quot;0 Md ¤&quot; ] } , { &quot;10000000000&quot; , [ one : &quot;00 Md ¤&quot; , other : &quot;00 Md ¤&quot; ] } , { &quot;100000000000&quot; , [ one : &quot;000 Md ¤&quot; , other : &quot;000 Md ¤&quot; ] } , { &quot;1000000000000&quot; , [ one : &quot;0 Bn ¤&quot; , other : &quot;0 Bn ¤&quot; ] } , { &quot;10000000000000&quot; , [ one : &quot;00 Bn ¤&quot; , other : &quot;00 Bn ¤&quot; ] } , { &quot;100000000000000&quot; , [ one : &quot;000 Bn ¤&quot; , other : &quot;000 Bn ¤&quot; ] } ] , ... } }","ref":"Cldr.Number.Format.html#formats_for/3","title":"Cldr.Number.Format.formats_for/3","type":"function"},{"doc":"Return the predfined formats for a given locale and number_system or raises if either the locale or number_system is invalid. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 number_system is any valid number system or number system type returned by Cldr.Number.System.number_systems_for/2 backend is any Cldr backend. That is, any module that contains use Cldr","ref":"Cldr.Number.Format.html#formats_for!/3","title":"Cldr.Number.Format.formats_for!/3","type":"function"},{"doc":"Returns the minium grouping digits for a locale. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/0 backend is any Cldr backend. That is, any module that contains use Cldr Returns {:ok, minumum_digits} or {:error, {exception, message}} Examples iex&gt; Cldr.Number.Format . minimum_grouping_digits_for ( &quot;en&quot; , MyApp.Cldr ) { :ok , 1 }","ref":"Cldr.Number.Format.html#minimum_grouping_digits_for/2","title":"Cldr.Number.Format.minimum_grouping_digits_for/2","type":"function"},{"doc":"Returns the minium grouping digits for a locale or raises if there is an error. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 backend is any Cldr backend. That is, any module that contains use Cldr Examples iex&gt; Cldr.Number.Format . minimum_grouping_digits_for! ( &quot;en&quot; , MyApp.Cldr ) 1 Cldr.Number.Format . minimum_grouping_digits_for! ( :invalid ) ** (Cldr.UnknownLocaleError) The locale :invalid is invalid","ref":"Cldr.Number.Format.html#minimum_grouping_digits_for!/2","title":"Cldr.Number.Format.minimum_grouping_digits_for!/2","type":"function"},{"doc":"","ref":"Cldr.Number.Format.html#short_format_styles/0","title":"Cldr.Number.Format.short_format_styles/0","type":"function"},{"doc":"Returns the short formats available for a locale. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 number_system is any valid number system or number system type returned by Cldr.Number.System.number_systems_for/2 backend is any Cldr backend. That is, any module that contains use Cldr Example iex&gt; Cldr.Number.Format . short_format_styles_for ( &quot;he&quot; , :latn , MyApp.Cldr ) { :ok , [ :currency_short , :decimal_long , :decimal_short ] }","ref":"Cldr.Number.Format.html#short_format_styles_for/3","title":"Cldr.Number.Format.short_format_styles_for/3","type":"function"},{"doc":"","ref":"Cldr.Number.Format.html#t:format/0","title":"Cldr.Number.Format.format/0","type":"type"},{"doc":"Compiles number patterns with a lexer/parser into patterns for fast runtime interpretation. Number patterns affect how numbers are interpreted in a localized context. Here are some examples, based on the French locale. The &quot;.&quot; shows where the decimal point should go. The &quot;,&quot; shows where the thousands separator should go. A &quot;0&quot; indicates zero-padding: if the number is too short, a zero (in the locale's numeric set) will go there. A &quot;#&quot; indicates no padding: if the number is too short, nothing goes there. A &quot;¤&quot; shows where the currency sign will go. The following illustrates the effects of different patterns for the French locale, with the number &quot;1234.567&quot;. Notice how the pattern characters ',' and '.' are replaced by the characters appropriate for the locale. Number Pattern Examples Pattern Currency Text #,##0.## n/a 1 234,57 #,##0.### n/a 1 234,567 ###0.##### n/a 1234,567 ###0.0000# n/a 1234,5670 00000.0000 n/a 01234,5670 #,##0.00 ¤ EUR 1 234,57 € The number of # placeholder characters before the decimal do not matter, since no limit is placed on the maximum number of digits. There should, however, be at least one zero someplace in the pattern. In currency formats, the number of digits after the decimal also do not matter, since the information in the supplemental data (see Supplemental Currency Data) is used to override the number of decimal places — and the rounding — according to the currency that is being formatted. That can be seen in the above chart, with the difference between Yen and Euro formatting. Special Pattern Characters Many characters in a pattern are taken literally; they are matched during parsing and output unchanged during formatting. Special characters, on the other hand, stand for other characters, strings, or classes of characters. For example, the '#' character is replaced by a localized digit for the chosen numberSystem. Often the replacement character is the same as the pattern character; in the U.S. locale, the ',' grouping character is replaced by ','. However, the replacement is still happening, and if the symbols are modified, the grouping character changes. Some special characters affect the behavior of the formatter by their presence; for example, if the percent character is seen, then the value is multiplied by 100 before being displayed. To insert a special character in a pattern as a literal, that is, without any special meaning, the character must be quoted. There are some exceptions to this which are noted below. Number Pattern Character Definitions Symbol Meaning 0 Digit 1..9 '1' through '9' indicate rounding to the nearest n @ Significant digit | Digit, omitting leading/trailing zeros . | Decimal separator or monetary decimal separator | Minus sign , | Grouping separator | Prefix positive exponents with localized plus sign % Multiply by 100 and show as percentage ‰ Multiply by 1000 and show as per mille (aka “basis points”) ; Separates positive and negative subpatterns ¤ Any sequence is replaced by the localized currency symbol | Pad escape , precedes pad character ' | Used to quote special characters in a prefix or suffix A pattern contains a positive subpattern and may contain a negative subpattern, for example, &quot;#,##0.00;(#,##0.00)&quot;. Each subpattern has a prefix, a numeric part, and a suffix. If there is no explicit negative subpattern, the implicit negative subpattern is the ASCII minus sign (-) prefixed to the positive subpattern. That is, &quot;0.00&quot; alone is equivalent to &quot;0.00;-0.00&quot;. (The data in CLDR is normalized to remove an explicit subpattern where it would be identical to the explicit form.) If there is an explicit negative subpattern, it serves only to specify the negative prefix and suffix; the number of digits, minimal digits, and other characteristics are ignored in the negative subpattern. That means that &quot;#,##0.0#;(#)&quot; has precisely the same result as &quot;#,##0.0#;(#,##0.0#)&quot;. However in the CLDR data, the format is normalized so that the other characteristics are preserved, just for readability. Note: The thousands separator and decimal separator in patterns are always ASCII ',' and '.'. They are substituted by the code with the correct local values according to other fields in CLDR. The same is true of the - (ASCII minus sign) and other special characters listed above. Extracted from Unicode number formats in TR35","ref":"Cldr.Number.Format.Compiler.html","title":"Cldr.Number.Format.Compiler","type":"module"},{"doc":"Parse a number format definition and analyze it. After parsing, reduce the format to a set of metrics that can then be used to format a number.","ref":"Cldr.Number.Format.Compiler.html#compile/1","title":"Cldr.Number.Format.Compiler.compile/1","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Compiler.html#exponent_sign/1","title":"Cldr.Number.Format.Compiler.exponent_sign/1","type":"function"},{"doc":"Extract the metadata from the format. The metadata is used to generate the formatted output. A numeric format is optional and in such cases no analysis is required.","ref":"Cldr.Number.Format.Compiler.html#format_to_metadata/1","title":"Cldr.Number.Format.Compiler.format_to_metadata/1","type":"function"},{"doc":"Returns an Elixir AST of a formatting pipeline that when executed produces the formatted output for a given format string. Not all formats require all parts of the full formatting pipeline so by compiling only those parts of the pipeline that are required we produce an optimal code path.","ref":"Cldr.Number.Format.Compiler.html#formatting_pipeline/1","title":"Cldr.Number.Format.Compiler.formatting_pipeline/1","type":"function"},{"doc":"A regular expression that can be used to split either a number format or a number itself. Since it accepts characters that are not digits (like '#', '@' and ',') it cannot be used to validate a number. Its only use is to split a number or a format into parts for later processing.","ref":"Cldr.Number.Format.Compiler.html#number_match_regex/0","title":"Cldr.Number.Format.Compiler.number_match_regex/0","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Compiler.html#padding_char/1","title":"Cldr.Number.Format.Compiler.padding_char/1","type":"function"},{"doc":"Parse a number format definition Using a yexx lexer, parse a nunber format definition into list of elements we can then interpret to format a number. Example iex&gt; Cldr.Number.Format.Compiler . parse &quot;¤ #,##0.00;¤-#,##0.00&quot; { :ok , [ positive : [ currency : 1 , literal : &quot; &quot; , format : &quot;#,##0.00&quot; ] , negative : [ currency : 1 , minus : &#39;-&#39; , format : :same_as_positive ] ] }","ref":"Cldr.Number.Format.Compiler.html#parse/1","title":"Cldr.Number.Format.Compiler.parse/1","type":"function"},{"doc":"Returns a number placeholder symbol. symbol is one of :decimal , group , :exponent , :plus , :minus , :currency These symbols are used in decimal number format and are replaced with locale-specific characters during number formatting. Example iex&gt; Cldr.Number.Format.Compiler . placeholder ( :plus ) &quot;+&quot;","ref":"Cldr.Number.Format.Compiler.html#placeholder/1","title":"Cldr.Number.Format.Compiler.placeholder/1","type":"function"},{"doc":"Scan a number format definition Using a leex lexer, tokenize a rule definition","ref":"Cldr.Number.Format.Compiler.html#tokenize/1","title":"Cldr.Number.Format.Compiler.tokenize/1","type":"function"},{"doc":"Describes the metadata that drives number formatting and provides functions to update the struct. Format definition The :format is a keyword list that with two elements: :positive which is a keyword list for formatting a number &gt;= zero :negative which is a keyword list for formatting negtive number There are two formats because we can format in an accounting style (that is, numbers surrounded by () ) or any other arbitrary style. Typically the format for a negative number is the same as that for a positive number with a prepended minus sign. Localisation of number formatting Number formatting is always localised to either the currency processes locale or a locale provided as an option to Cldr.Number.to_string/3 . The metadata is independent of the localisation process. Signs ( + / - ), grouping ( , ), decimal markers ( . ) and exponent signs are all localised when the number is formatted. Formatting directives The formats - positive and negative - are defined in the metadata struct, as a keyword list of keywords and values. The simplest formatting list might be: [ format : _ ] ` The :format keyword indicates that this is where the formatting number will be substituted into the format pattern. Another example would be for formatting a negative number: [ minus : _ , format : _ ] which will format with a localised minus sign followed by the formatted number. Note that the keyword value for :minus and :format are ignored. List of formatting keywords The following is the full list of formatting keywords which can be used to format a number. A _ in the keyword format is used to denote :dont_care . [format: _] inserts the formatted number exclusive of any sign [minus: _] inserts a localised minus sign [plus: _] inserts a localised plus sign [percent: _] inserts a localised percent sign [permille: _] inserts a localised permille sign [literal: &quot;string&quot;] inserts string into the format without any processing [currency: 1..4] inserts a localised currency symbol of the given type . A :currency must be provided as an option to Cldr.Number.Formatter.Decimal.to_string/3 . [pad: &quot;char&quot;] inserts the correct number of char s to pad the number format to the width specified by :padding_length in the %Meta{} struct. The :pad can be anywhere in the format list but it is most typically inserted before or after the :format keyword. The assumption is tha the char is a single binary character but this is not checked. Currency symbol formatting Currency are localised and have four ways of being presented. The different types are defined in the [currency: type] keyword where type is an integer in the range 1..4 These types will insert into the final format: The standard currency symbol like $ , ¥ or € The ISO currency code (like USD and JPY ) The localised and pluralised currency display name like &quot;Australian dollar&quot; or &quot;Australian dollars&quot; The narrow currency symbol if defined for a locale","ref":"Cldr.Number.Format.Meta.html","title":"Cldr.Number.Format.Meta","type":"module"},{"doc":"Returns a new number formatting metadata struct.","ref":"Cldr.Number.Format.Meta.html#new/0","title":"Cldr.Number.Format.Meta.new/0","type":"function"},{"doc":"Set the number of exponent digits to format.","ref":"Cldr.Number.Format.Meta.html#put_exponent_digits/2","title":"Cldr.Number.Format.Meta.put_exponent_digits/2","type":"function"},{"doc":"Set whether to add the sign of the exponent to the format.","ref":"Cldr.Number.Format.Meta.html#put_exponent_sign/2","title":"Cldr.Number.Format.Meta.put_exponent_sign/2","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Meta.html#put_format/2","title":"Cldr.Number.Format.Meta.put_format/2","type":"function"},{"doc":"Set the metadata format for the positive and negative number format. Note that this is the parsed format as a simple keyword list, not a binary representation. Its up to each formatting engine to transform its input into this form. See Cldr.Number.Format.Meta module documentation for the available keywords.","ref":"Cldr.Number.Format.Meta.html#put_format/3","title":"Cldr.Number.Format.Meta.put_format/3","type":"function"},{"doc":"Set the minimum, and optionally maximum, fractional digits to format.","ref":"Cldr.Number.Format.Meta.html#put_fraction_digits/3","title":"Cldr.Number.Format.Meta.put_fraction_digits/3","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Meta.html#put_fraction_grouping/2","title":"Cldr.Number.Format.Meta.put_fraction_grouping/2","type":"function"},{"doc":"Sets the number of digits in a group or optionally the first group and subsequent groups for the fractional part of a number. The grouping character is defined by the locale defined for the current process or supplied as the :locale option to to_string/3 .","ref":"Cldr.Number.Format.Meta.html#put_fraction_grouping/3","title":"Cldr.Number.Format.Meta.put_fraction_grouping/3","type":"function"},{"doc":"Set the minimum, and optionally maximum, integer digits to format.","ref":"Cldr.Number.Format.Meta.html#put_integer_digits/3","title":"Cldr.Number.Format.Meta.put_integer_digits/3","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Meta.html#put_integer_grouping/2","title":"Cldr.Number.Format.Meta.put_integer_grouping/2","type":"function"},{"doc":"Sets the number of digits in a group or optionally the first group and subsequent groups for the integer part of a number. The grouping character is defined by the locale defined for the current process or supplied as the :locale option to to_string/3 .","ref":"Cldr.Number.Format.Meta.html#put_integer_grouping/3","title":"Cldr.Number.Format.Meta.put_integer_grouping/3","type":"function"},{"doc":"Sets the multiplier for the number. Before formatting, the number is multiplied by this amount. This is useful when formatting as a percent or permille.","ref":"Cldr.Number.Format.Meta.html#put_multiplier/2","title":"Cldr.Number.Format.Meta.put_multiplier/2","type":"function"},{"doc":"Set the padding character to be used when padding the formatted number.","ref":"Cldr.Number.Format.Meta.html#put_padding_char/2","title":"Cldr.Number.Format.Meta.put_padding_char/2","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Meta.html#put_padding_length/2","title":"Cldr.Number.Format.Meta.put_padding_length/2","type":"function"},{"doc":"Set the increment to which the number should be rounded.","ref":"Cldr.Number.Format.Meta.html#put_round_nearest_digits/2","title":"Cldr.Number.Format.Meta.put_round_nearest_digits/2","type":"function"},{"doc":"Set the number of scientific digits to which the number should be rounded.","ref":"Cldr.Number.Format.Meta.html#put_scientific_rounding_digits/2","title":"Cldr.Number.Format.Meta.put_scientific_rounding_digits/2","type":"function"},{"doc":"Set the minimum, and optionally maximum, significant digits to format.","ref":"Cldr.Number.Format.Meta.html#put_significant_digits/3","title":"Cldr.Number.Format.Meta.put_significant_digits/3","type":"function"},{"doc":"Metadata type that drives how to format a number","ref":"Cldr.Number.Format.Meta.html#t:t/0","title":"Cldr.Number.Format.Meta.t/0","type":"type"},{"doc":"Functions to validate and transform options that guide number formatting","ref":"Cldr.Number.Format.Options.html","title":"Cldr.Number.Format.Options","type":"module"},{"doc":"","ref":"Cldr.Number.Format.Options.html#confirm_currency_format_has_currency_code/1","title":"Cldr.Number.Format.Options.confirm_currency_format_has_currency_code/1","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Options.html#ensure_only_valid_keys/2","title":"Cldr.Number.Format.Options.ensure_only_valid_keys/2","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Options.html#maybe_set_iso_currency_symbol/1","title":"Cldr.Number.Format.Options.maybe_set_iso_currency_symbol/1","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Options.html#resolve_standard_format/2","title":"Cldr.Number.Format.Options.resolve_standard_format/2","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Options.html#set_pattern/2","title":"Cldr.Number.Format.Options.set_pattern/2","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Options.html#short_format_styles/0","title":"Cldr.Number.Format.Options.short_format_styles/0","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Options.html#structify/2","title":"Cldr.Number.Format.Options.structify/2","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Options.html#validate_option/4","title":"Cldr.Number.Format.Options.validate_option/4","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Options.html#validate_options/3","title":"Cldr.Number.Format.Options.validate_options/3","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Options.html#validate_other_format/3","title":"Cldr.Number.Format.Options.validate_other_format/3","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Options.html#wrap_ok/1","title":"Cldr.Number.Format.Options.wrap_ok/1","type":"function"},{"doc":"","ref":"Cldr.Number.Format.Options.html#t:currency_symbol/0","title":"Cldr.Number.Format.Options.currency_symbol/0","type":"type"},{"doc":"","ref":"Cldr.Number.Format.Options.html#t:fixed_formats/0","title":"Cldr.Number.Format.Options.fixed_formats/0","type":"type"},{"doc":"","ref":"Cldr.Number.Format.Options.html#t:format/0","title":"Cldr.Number.Format.Options.format/0","type":"type"},{"doc":"","ref":"Cldr.Number.Format.Options.html#t:short_format_styles/0","title":"Cldr.Number.Format.Options.short_format_styles/0","type":"type"},{"doc":"","ref":"Cldr.Number.Format.Options.html#t:t/0","title":"Cldr.Number.Format.Options.t/0","type":"type"},{"doc":"Number formatter for the :currency :long format. This formatter implements formatting a currency in a long form. This is not the same as decimal formatting with a currency placeholder. To explain the difference, look at the following examples: iex&gt; Cldr.Number . to_string 123 , TestBackend.Cldr , format : :currency , currency : &quot;USD&quot; { :ok , &quot;$123.00&quot; } iex&gt; Cldr.Number . to_string 123 , TestBackend.Cldr , format : :long , currency : &quot;USD&quot; { :ok , &quot;123 US dollars&quot; } In the first example the format is defined by a decimal mask. In this example the format mask comes from: iex&gt; { :ok , formats } = Cldr.Number.Format . all_formats_for ( &quot;en&quot; , TestBackend.Cldr ) ...&gt; formats . latn . currency &quot;¤#,##0.00&quot; In the second example we are using a format that combines the number with a language translation of the currency name. In this example the format comes from: iex&gt; { :ok , formats } = Cldr.Number.Format . all_formats_for ( &quot;en&quot; , TestBackend.Cldr ) ...&gt; formats . latn . currency_long %{ one : [ 0 , &quot; &quot; , 1 ] , other : [ 0 , &quot; &quot; , 1 ] } Where &quot;{0}&quot; is replaced with the number formatted using the :standard decimal format and &quot;{1} is replaced with locale-specific name of the currency adjusted for the locales plural rules.&quot; This module is not part of the public API and is subject to change at any time.","ref":"Cldr.Number.Formatter.Currency.html","title":"Cldr.Number.Formatter.Currency","type":"module"},{"doc":"","ref":"Cldr.Number.Formatter.Currency.html#to_string/4","title":"Cldr.Number.Formatter.Currency.to_string/4","type":"function"},{"doc":"Formats a number according to a locale-specific predefined format or a user-defined format. As a performance optimization, all decimal formats known at compile time are compiled into function that roughly halves the time to format a number compared to a non-precompiled format. The available format styles for a locale can be returned by: iex&gt; Cldr.Number.Format . decimal_format_styles_for ( &quot;en&quot; , :latn , TestBackend.Cldr ) { :ok , [ :accounting , :currency , :currency_long , :percent , :scientific , :standard ] } This allows a number to be formatted in a locale-specific way but using a standard method of describing the purpose of the format. This module is not part of the public API and is subject to change at any time.","ref":"Cldr.Number.Formatter.Decimal.html","title":"Cldr.Number.Formatter.Decimal","type":"module"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#absolute_value/4","title":"Cldr.Number.Formatter.Decimal.absolute_value/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#add_first_group/3","title":"Cldr.Number.Formatter.Decimal.add_first_group/3","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#add_last_group/3","title":"Cldr.Number.Formatter.Decimal.add_last_group/3","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#add_separator/3","title":"Cldr.Number.Formatter.Decimal.add_separator/3","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#adjust_for_fractional_digits/2","title":"Cldr.Number.Formatter.Decimal.adjust_for_fractional_digits/2","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#adjust_for_integer_digits/2","title":"Cldr.Number.Formatter.Decimal.adjust_for_integer_digits/2","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#adjust_for_round_nearest/2","title":"Cldr.Number.Formatter.Decimal.adjust_for_round_nearest/2","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#adjust_fraction_for_currency/4","title":"Cldr.Number.Formatter.Decimal.adjust_fraction_for_currency/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#adjust_fraction_for_significant_digits/2","title":"Cldr.Number.Formatter.Decimal.adjust_fraction_for_significant_digits/2","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#adjust_leading_zeros/4","title":"Cldr.Number.Formatter.Decimal.adjust_leading_zeros/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#adjust_trailing_zeros/4","title":"Cldr.Number.Formatter.Decimal.adjust_trailing_zeros/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#apply_grouping/4","title":"Cldr.Number.Formatter.Decimal.apply_grouping/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#assemble_format/4","title":"Cldr.Number.Formatter.Decimal.assemble_format/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#currency_symbol/6","title":"Cldr.Number.Formatter.Decimal.currency_symbol/6","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#do_adjust_fraction/3","title":"Cldr.Number.Formatter.Decimal.do_adjust_fraction/3","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#do_grouping/5","title":"Cldr.Number.Formatter.Decimal.do_grouping/5","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#do_max_integer_digits/2","title":"Cldr.Number.Formatter.Decimal.do_max_integer_digits/2","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#do_trailing_zeros/2","title":"Cldr.Number.Formatter.Decimal.do_trailing_zeros/2","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#minimum_group_size/4","title":"Cldr.Number.Formatter.Decimal.minimum_group_size/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#multiply_by_factor/4","title":"Cldr.Number.Formatter.Decimal.multiply_by_factor/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#output_to_tuple/4","title":"Cldr.Number.Formatter.Decimal.output_to_tuple/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#padding_string/2","title":"Cldr.Number.Formatter.Decimal.padding_string/2","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#reassemble_number_string/4","title":"Cldr.Number.Formatter.Decimal.reassemble_number_string/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#round_fractional_digits/4","title":"Cldr.Number.Formatter.Decimal.round_fractional_digits/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#round_to_nearest/4","title":"Cldr.Number.Formatter.Decimal.round_to_nearest/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#round_to_significant_digits/4","title":"Cldr.Number.Formatter.Decimal.round_to_significant_digits/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#set_exponent/4","title":"Cldr.Number.Formatter.Decimal.set_exponent/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#set_max_integer_digits/4","title":"Cldr.Number.Formatter.Decimal.set_max_integer_digits/4","type":"function"},{"doc":"Formats a number according to a decimal format string. Arguments number is an integer, float or Decimal format is a format string. See Cldr.Number for further information. backend is any module that includes use Cldr and therefore is a Cldr backend module options is a map of options. See Cldr.Number.to_string/2 for further information.","ref":"Cldr.Number.Formatter.Decimal.html#to_string/4","title":"Cldr.Number.Formatter.Decimal.to_string/4","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Decimal.html#transliterate/4","title":"Cldr.Number.Formatter.Decimal.transliterate/4","type":"function"},{"doc":"Formats a number according to the locale-specific :short formats This is best explained by some examples: iex&gt; Cldr.Number . to_string 123 , TestBackend.Cldr , format : :short { :ok , &quot;123&quot; } iex&gt; Cldr.Number . to_string 1234 , TestBackend.Cldr , format : :short { :ok , &quot;1K&quot; } iex&gt; Cldr.Number . to_string 523456789 , TestBackend.Cldr , format : :short { :ok , &quot;523M&quot; } iex&gt; Cldr.Number . to_string 7234567890 , TestBackend.Cldr , format : :short { :ok , &quot;7B&quot; } iex&gt; Cldr.Number . to_string 7234567890 , TestBackend.Cldr , format : :long { :ok , &quot;7 billion&quot; } These formats are compact representations however they do lose precision in the presentation in favour of human readibility. Note that for a :currency short format the number of decimal places is retrieved from the currency definition itself. You can see the difference in the following examples: iex&gt; Cldr.Number . to_string 1234 , TestBackend.Cldr , format : :short , currency : &quot;EUR&quot; { :ok , &quot;€1K&quot; } iex&gt; Cldr.Number . to_string 1234 , TestBackend.Cldr , format : :short , currency : &quot;EUR&quot; , fractional_digits : 2 { :ok , &quot;€1.23K&quot; } iex&gt; Cldr.Number . to_string 1234 , TestBackend.Cldr , format : :short , currency : &quot;JPY&quot; { :ok , &quot;¥1K&quot; } This module is not part of the public API and is subject to change at any time.","ref":"Cldr.Number.Formatter.Short.html","title":"Cldr.Number.Formatter.Short","type":"module"},{"doc":"Returns the exponent that will be applied when formatting the given number as a short format. This function is primarily intended to support pluralization for compact numbers (numbers formatted with the format: :short option) since some languages pluralize compact numbers differently to a fully expressed number. Such rules are defined for the locale &quot;fr&quot; from CLDR version 38 with the intention that additional rules will be added in later versions. Examples iex&gt; Cldr.Number.Formatter.Short . short_format_exponent 1234 { 1000 , 1 } iex&gt; Cldr.Number.Formatter.Short . short_format_exponent 12345 { 10000 , 2 } iex&gt; Cldr.Number.Formatter.Short . short_format_exponent 123456789 { 100000000 , 3 } iex&gt; Cldr.Number.Formatter.Short . short_format_exponent 123456789 , locale : &quot;th&quot; { 100000000 , 3 }","ref":"Cldr.Number.Formatter.Short.html#short_format_exponent/2","title":"Cldr.Number.Formatter.Short.short_format_exponent/2","type":"function"},{"doc":"","ref":"Cldr.Number.Formatter.Short.html#to_string/4","title":"Cldr.Number.Formatter.Short.to_string/4","type":"function"},{"doc":"Functions for parsing numbers and currencies from a string.","ref":"Cldr.Number.Parser.html","title":"Cldr.Number.Parser","type":"module"},{"doc":"Find a substring at the beginning and/or end of a string, and replace it. Ignore any whitespace found at the start or end of the string when looking for a match. A match is considered only if there is no alphabetic character adjacent to the match. When multiple matches are found, the longest match is replaced. Arguments string_map is a map where the keys are the strings to be matched and the values are the replacement. string is the string in which the find and replace operation takes place. fuzzy is floating point number between 0.0 and 1.0 that is used to implement a fuzzy match using String.jaro_distance/2 . The default is nil which means the match is exact at the beginning and/or the end of the string . Returns {:ok, list} where list is string broken into the replacement(s) and the remainder after find and replace. Or {:error, {exception, reason}} will be returned if the fuzzy parameter is invalid or if no search was found and no replacement made. In the later case, exception will be Cldr.Number.ParseError . Examples iex&gt; Cldr.Number.Parser . find_and_replace ( %{ &quot;this&quot; =&gt; &quot;that&quot; } , &quot;This is a string&quot; ) { :ok , [ &quot;that&quot; , &quot; is a string&quot; ] } iex&gt; Cldr.Number.Parser . find_and_replace ( %{ &quot;string&quot; =&gt; &quot;term&quot; } , &quot;This is a string&quot; ) { :ok , [ &quot;This is a &quot; , &quot;term&quot; ] } iex&gt; Cldr.Number.Parser . find_and_replace ( %{ &quot;string&quot; =&gt; &quot;term&quot; , &quot;this&quot; =&gt; &quot;that&quot; } , &quot;This is a string&quot; ) { :ok , [ &quot;that&quot; , &quot; is a &quot; , &quot;term&quot; ] } iex&gt; Cldr.Number.Parser . find_and_replace ( %{ &quot;unknown&quot; =&gt; &quot;term&quot; } , &quot;This is a string&quot; ) { :error , { Cldr.Number.ParseError , &quot;No match was found&quot; } }","ref":"Cldr.Number.Parser.html#find_and_replace/3","title":"Cldr.Number.Parser.find_and_replace/3","type":"function"},{"doc":"Parse a string in a locale-aware manner and return a number. Arguments string is any t:String options is a keyword list of options Options :number is one of :integer , :float , :decimal or nil . The default is nil meaning that the type auto-detected as either an integer or a float . :backend is any module that includes use Cldr and is therefore a CLDR backend module. The default is Cldr.default_backend/0 . :locale is any locale returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag.t . The default is options[:backend].get_locale/1 . Returns A number of the requested or default type or {:error, {exception, message}} if no number could be determined Notes This function parses a string to return a number but in a locale-aware manner. It will normalise digits, grouping characters and decimal separators. It will transliterate digits that are in the number system of the specific locale. For example, if the locale is th (Thailand), then Thai digits are transliterated to the Latin script before parsing. Some number systems do not have decimal digits and in this case an error will be returned, rather than continue parsing and return misleading results. It also caters for different forms of the + and - symbols that appear in Unicode and strips any _ characters that might be used for formatting in a string. It then parses the number using the Elixir standard library functions. If the option :number is used and the parsed number cannot be coerced to this type without losing precision then an error is returned. Examples iex&gt; Cldr.Number.Parser . parse ( &quot;＋1.000,34&quot; , locale : &quot;de&quot; ) { :ok , 1000.34 } iex&gt; Cldr.Number.Parser . parse ( &quot;-1_000_000.34&quot; ) { :ok , - 1000000.34 } iex&gt; Cldr.Number.Parser . parse ( &quot;1.000&quot; , locale : &quot;de&quot; , number : :integer ) { :ok , 1000 } iex&gt; Cldr.Number.Parser . parse &quot;١٢٣٤٥&quot; , locale : &quot;ar&quot; { :ok , 12345 } # 1_000.34 cannot be coerced into an integer # without precision loss so an error is returned. iex&gt; Cldr.Number.Parser . parse ( &quot;＋1.000,34&quot; , locale : &quot;de&quot; , number : :integer ) { :error , { Cldr.Number.ParseError , &quot;The string \\&quot; ＋1.000,34 \\&quot; could not be parsed as a number&quot; } } iex&gt; Cldr.Number.Parser . parse &quot;一万二千三百四十五&quot; , locale : &quot;ja-u-nu-jpan&quot; { :error , { Cldr.UnknownNumberSystemError , &quot;The number system :jpan is not known or does not have digits&quot; } }","ref":"Cldr.Number.Parser.html#parse/2","title":"Cldr.Number.Parser.parse/2","type":"function"},{"doc":"Removes any whitespace strings from between tokens in a list. Tokens are numbers or atoms.","ref":"Cldr.Number.Parser.html#remove_whitespace_between_tokens/1","title":"Cldr.Number.Parser.remove_whitespace_between_tokens/1","type":"function"},{"doc":"Maps a list of terms (usually strings and atoms) calling a resolver function that operates on each binary term. If the resolver function returns {:error, term} then no change is made to the term, otherwise the return value of the resolver replaces the original term. Arguments list is a list of terms. Typically this is the result of calling Cldr.Number.Parser.scan/1 . resolver is a function that takes two arguments. The first is one of the terms in the list . The second is options . options is a keyword list of options that is passed to the resolver function. Note The resolver is called only on binary elements of the list. Returns list as modified through the application of the resolver function on each bianry term. Examples See Cldr.Number.Parser.resolve_currencies/2 and Cldr.Number.Parser.resolve_pers/2 which both use this function.","ref":"Cldr.Number.Parser.html#resolve/3","title":"Cldr.Number.Parser.resolve/3","type":"function"},{"doc":"Resolve curencies from strings within a list. Currencies can be identified at the beginning and/or the end of a string. Arguments list is any list in which currency names and symbols are expected options is a keyword list of options Options :backend is any module() that includes use Cldr and therefore is a Cldr backend module(). The default is Cldr.default_backend!/0 :locale is any valid locale returned by Cldr.known_locale_names/1 or a t:Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 The default is options[:backend].get_locale() :only is an atom or list of atoms representing the currencies or currency types to be considered for a match. The equates to a list of acceptable currencies for parsing. See the notes below for currency types. :except is an atom or list of atoms representing the currencies or currency types to be not considered for a match. This equates to a list of unacceptable currencies for parsing. See the notes below for currency types. :fuzzy is a float greater than 0.0 and less than or equal to 1.0 which is used as input to String.jaro_distance/2 to determine is the provided currency string is close enough to a known currency string for it to identify definitively a currency code. It is recommended to use numbers greater than 0.8 in order to reduce false positives. Returns An ISO4217 currency code as an atom or {:error, {exception, message}} Notes The :only and :except options accept a list of currency codes and/or currency types. The following types are recognised. If both :only and :except are specified, the :except entries take priority - that means any entries in :except are removed from the :only entries. :all , the default, considers all currencies :current considers those currencies that have a :to date of nil and which also is a known ISO4217 currency :historic is the opposite of :current :tender considers currencies that are legal tender :unannotated considers currencies that don't have &quot;(some string)&quot; in their names. These are usually financial instruments. Examples iex&gt; Cldr.Number.Parser . scan ( &quot;100 US dollars&quot; ) ...&gt; |&gt; Cldr.Number.Parser . resolve_currencies [ 100 , :USD ] iex&gt; Cldr.Number.Parser . scan ( &quot;100 eurosports&quot; ) ...&gt; |&gt; Cldr.Number.Parser . resolve_currencies ( fuzzy : 0.8 ) [ 100 , :EUR ] iex&gt; Cldr.Number.Parser . scan ( &quot;100 dollars des États-Unis&quot; ) ...&gt; |&gt; Cldr.Number.Parser . resolve_currencies ( locale : &quot;fr&quot; ) [ 100 , :USD ]","ref":"Cldr.Number.Parser.html#resolve_currencies/2","title":"Cldr.Number.Parser.resolve_currencies/2","type":"function"},{"doc":"Resolve a currency from the beginning and/or the end of a string Arguments list is any list in which currency names and symbols are expected options is a keyword list of options Options :backend is any module() that includes use Cldr and therefore is a Cldr backend module(). The default is Cldr.default_backend!/0 :locale is any valid locale returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 The default is options[:backend].get_locale() :only is an atom or list of atoms representing the currencies or currency types to be considered for a match. The equates to a list of acceptable currencies for parsing. See the notes below for currency types. :except is an atom or list of atoms representing the currencies or currency types to be not considered for a match. This equates to a list of unacceptable currencies for parsing. See the notes below for currency types. :fuzzy is a float greater than 0.0 and less than or equal to 1.0 which is used as input to String.jaro_distance/2 to determine is the provided currency string is close enough to a known currency string for it to identify definitively a currency code. It is recommended to use numbers greater than 0.8 in order to reduce false positives. Returns An ISO417 currency code as an atom or {:error, {exception, message}} Notes The :only and :except options accept a list of currency codes and/or currency types. The following types are recognised. If both :only and :except are specified, the :except entries take priority - that means any entries in :except are removed from the :only entries. :all , the default, considers all currencies :current considers those currencies that have a :to date of nil and which also is a known ISO4217 currency :historic is the opposite of :current :tender considers currencies that are legal tender :unannotated considers currencies that don't have &quot;(some string)&quot; in their names. These are usually financial instruments. Examples iex&gt; Cldr.Number.Parser . resolve_currency ( &quot;US dollars&quot; ) [ :USD ] iex&gt; Cldr.Number.Parser . resolve_currency ( &quot;100 eurosports&quot; , fuzzy : 0.75 ) [ :EUR ] iex&gt; Cldr.Number.Parser . resolve_currency ( &quot;dollars des États-Unis&quot; , locale : &quot;fr&quot; ) [ :USD ] iex&gt; Cldr.Number.Parser . resolve_currency ( &quot;not a known currency&quot; , locale : &quot;fr&quot; ) { :error , { Cldr.UnknownCurrencyError , &quot;The currency \\&quot; not a known currency \\&quot; is unknown or not supported&quot; } }","ref":"Cldr.Number.Parser.html#resolve_currency/2","title":"Cldr.Number.Parser.resolve_currency/2","type":"function"},{"doc":"Resolve and tokenize percent or permille from the beginning and/or the end of a string Arguments list is any list in which percent and permille symbols are expected options is a keyword list of options Options :backend is any module() that includes use Cldr and therefore is a Cldr backend module(). The default is Cldr.default_backend!/0 :locale is any valid locale returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 The default is options[:backend].get_locale() Returns An :percent or permille or {:error, {exception, message}} Examples iex&gt; Cldr.Number.Parser . resolve_per &quot;11%&quot; [ &quot;11&quot; , :percent ] iex&gt; Cldr.Number.Parser . resolve_per &quot;% of linguists&quot; [ :percent , &quot; of linguists&quot; ] iex&gt; Cldr.Number.Parser . resolve_per &quot;% of linguists %&quot; [ :percent , &quot; of linguists &quot; , :percent ]","ref":"Cldr.Number.Parser.html#resolve_per/2","title":"Cldr.Number.Parser.resolve_per/2","type":"function"},{"doc":"Resolve and tokenize percent and permille sybols from strings within a list. Percent and permille symbols can be identified at the beginning and/or the end of a string. Arguments list is any list in which percent and permille symbols are expected options is a keyword list of options Options :backend is any module() that includes use Cldr and therefore is a Cldr backend module(). The default is Cldr.default_backend!/0 :locale is any valid locale returned by Cldr.known_locale_names/1 or a t:Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 The default is options[:backend].get_locale() Examples iex&gt; Cldr.Number.Parser . scan ( &quot;100%&quot; ) ...&gt; |&gt; Cldr.Number.Parser . resolve_pers ( ) [ 100 , :percent ]","ref":"Cldr.Number.Parser.html#resolve_pers/2","title":"Cldr.Number.Parser.resolve_pers/2","type":"function"},{"doc":"Scans a string in a locale-aware manner and returns a list of strings and numbers. Arguments string is any String.t options is a keyword list of options Options :number is one of :integer , :float , :decimal or nil . The default is nil meaning that the type auto-detected as either an integer or a float . :backend is any module that includes use Cldr and is therefore a CLDR backend module. The default is Cldr.default_backend!/0 . :locale is any locale returned by Cldr.known_locale_names/1 or a t:Cldr.LanguageTag . The default is options[:backend].get_locale/1 . Returns A list of strings and numbers Notes Number parsing is performed by Cldr.Number.Parser.parse/2 and any options provided are passed to that function. Examples iex&gt; Cldr.Number.Parser . scan ( &quot;£1_000_000.34&quot; ) [ &quot;£&quot; , 1000000.34 ] iex&gt; Cldr.Number.Parser . scan ( &quot;I want £1_000_000 dollars&quot; ) [ &quot;I want £&quot; , 1000000 , &quot; dollars&quot; ] iex&gt; Cldr.Number.Parser . scan ( &quot;The prize is 23&quot; ) [ &quot;The prize is &quot; , 23 ] iex&gt; Cldr.Number.Parser . scan ( &quot;The lottery number is 23 for the next draw&quot; ) [ &quot;The lottery number is &quot; , 23 , &quot; for the next draw&quot; ] iex&gt; Cldr.Number.Parser . scan ( &quot;The loss is -1.000 euros&quot; , locale : &quot;de&quot; , number : :integer ) [ &quot;The loss is &quot; , - 1000 , &quot; euros&quot; ] iex&gt; Cldr.Number.Parser . scan &quot;1kg&quot; [ 1 , &quot;kg&quot; ] iex&gt; Cldr.Number.Parser . scan &quot;A number is the arab script ١٢٣٤٥&quot; , locale : &quot;ar&quot; [ &quot;A number is the arab script &quot; , 12345 ]","ref":"Cldr.Number.Parser.html#scan/2","title":"Cldr.Number.Parser.scan/2","type":"function"},{"doc":"","ref":"Cldr.Number.Parser.html#t:per/0","title":"Cldr.Number.Parser.per/0","type":"type"},{"doc":"Functions to manage the symbol definitions for a locale and number system.","ref":"Cldr.Number.Symbol.html","title":"Cldr.Number.Symbol","type":"module"},{"doc":"Returns a list of all decimal symbols defined by the locales configured in the given backend as a list. Arguments backend is any module that includes use Cldr and therefore is a Cldr backend module","ref":"Cldr.Number.Symbol.html#all_decimal_symbols/1","title":"Cldr.Number.Symbol.all_decimal_symbols/1","type":"function"},{"doc":"Returns a list of all decimal symbols defined by the locales configured in the given backend as a string. This string can be used as a character class when builing a regular expression. Arguments backend is any module that includes use Cldr and therefore is a Cldr backend module","ref":"Cldr.Number.Symbol.html#all_decimal_symbols_class/1","title":"Cldr.Number.Symbol.all_decimal_symbols_class/1","type":"function"},{"doc":"Returns a list of all grouping symbols defined by the locales configured in the given backend as a list. Arguments backend is any module that includes use Cldr and therefore is a Cldr backend module","ref":"Cldr.Number.Symbol.html#all_grouping_symbols/1","title":"Cldr.Number.Symbol.all_grouping_symbols/1","type":"function"},{"doc":"Returns a list of all grouping symbols defined by the locales configured in the given backend as a string. This string can be used as a character class when builing a regular expression. Arguments backend is any module that includes use Cldr and therefore is a Cldr backend module","ref":"Cldr.Number.Symbol.html#all_grouping_symbols_class/1","title":"Cldr.Number.Symbol.all_grouping_symbols_class/1","type":"function"},{"doc":"Returns a map of Cldr.Number.Symbol.t structs of the number symbols for each of the number systems of a locale. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 . backend is any module that includes use Cldr and therefore is a Cldr backend module Example: iex&gt; Cldr.Number.Symbol . number_symbols_for ( &quot;th&quot; , TestBackend.Cldr ) { :ok , %{ latn : % Cldr.Number.Symbol { decimal : &quot;.&quot; , exponential : &quot;E&quot; , group : &quot;,&quot; , infinity : &quot;∞&quot; , list : &quot;;&quot; , minus_sign : &quot;-&quot; , nan : &quot;NaN&quot; , per_mille : &quot;‰&quot; , percent_sign : &quot;%&quot; , plus_sign : &quot;+&quot; , superscripting_exponent : &quot;×&quot; , time_separator : &quot;:&quot; } , thai : % Cldr.Number.Symbol { decimal : &quot;.&quot; , exponential : &quot;E&quot; , group : &quot;,&quot; , infinity : &quot;∞&quot; , list : &quot;;&quot; , minus_sign : &quot;-&quot; , nan : &quot;NaN&quot; , per_mille : &quot;‰&quot; , percent_sign : &quot;%&quot; , plus_sign : &quot;+&quot; , superscripting_exponent : &quot;×&quot; , time_separator : &quot;:&quot; } } }","ref":"Cldr.Number.Symbol.html#number_symbols_for/2","title":"Cldr.Number.Symbol.number_symbols_for/2","type":"function"},{"doc":"Returns the number sysbols for a specific locale and number system. Options locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/1 . number_system is any number system name returned by Cldr.known_number_systems/0 or a number system type returned by Cldr.known_number_system_types/0 backend is any module that includes use Cldr and therefore is a Cldr backend module Example iex&gt; Cldr.Number.Symbol . number_symbols_for ( &quot;th&quot; , &quot;thai&quot; , TestBackend.Cldr ) { :ok , % Cldr.Number.Symbol { decimal : &quot;.&quot; , exponential : &quot;E&quot; , group : &quot;,&quot; , infinity : &quot;∞&quot; , list : &quot;;&quot; , minus_sign : &quot;-&quot; , nan : &quot;NaN&quot; , per_mille : &quot;‰&quot; , percent_sign : &quot;%&quot; , plus_sign : &quot;+&quot; , superscripting_exponent : &quot;×&quot; , time_separator : &quot;:&quot; } }","ref":"Cldr.Number.Symbol.html#number_symbols_for/3","title":"Cldr.Number.Symbol.number_symbols_for/3","type":"function"},{"doc":"","ref":"Cldr.Number.Symbol.html#t:t/0","title":"Cldr.Number.Symbol.t/0","type":"type"},{"doc":"Functions to manage number systems which describe the numbering characteristics for a locale. A number system defines the digits (if they exist in this number system) or or rules (if the number system does not have decimal digits). The system name is also used as a key to define the separators that are used when formatting a number is this number_system. See Cldr.Number.Symbol.number_symbols_for/2 .","ref":"Cldr.Number.System.html","title":"Cldr.Number.System","type":"module"},{"doc":"Return the default number system type name. Currently this is :default . Note that this is not the number system itself but the type of the number system. It can be used to find the default number system for a given locale with number_systems_for(locale)[default_number_system()] . Example iex&gt; Cldr.Number.System . default_number_system_type :default","ref":"Cldr.Number.System.html#default_number_system_type/0","title":"Cldr.Number.System.default_number_system_type/0","type":"function"},{"doc":"Generate a transliteration map between two character classes Arguments from is any String.t() intended to represent the digits of a number system but thats not a requirement. to is any String.t() that is the same length as from intended to represent the digits of a number system. Returns A map where the keys are the graphemes in from and the values are the graphemes in to or {:error, {exception, reason}} Examples iex&gt; Cldr.Number.System . generate_transliteration_map &quot;0123456789&quot; , &quot;9876543210&quot; %{ &quot;0&quot; =&gt; &quot;9&quot; , &quot;1&quot; =&gt; &quot;8&quot; , &quot;2&quot; =&gt; &quot;7&quot; , &quot;3&quot; =&gt; &quot;6&quot; , &quot;4&quot; =&gt; &quot;5&quot; , &quot;5&quot; =&gt; &quot;4&quot; , &quot;6&quot; =&gt; &quot;3&quot; , &quot;7&quot; =&gt; &quot;2&quot; , &quot;8&quot; =&gt; &quot;1&quot; , &quot;9&quot; =&gt; &quot;0&quot; } iex&gt; Cldr.Number.System . generate_transliteration_map &quot;0123456789&quot; , &quot;987654321&quot; { :error , { ArgumentError , &quot; \\&quot; 0123456789 \\&quot; and \\&quot; 987654321 \\&quot; aren&#39;t the same length&quot; } }","ref":"Cldr.Number.System.html#generate_transliteration_map/2","title":"Cldr.Number.System.generate_transliteration_map/2","type":"function"},{"doc":"See Cldr.known_number_system_types/1 .","ref":"Cldr.Number.System.html#known_number_system_types/1","title":"Cldr.Number.System.known_number_system_types/1","type":"function"},{"doc":"See Cldr.known_number_systems/0 .","ref":"Cldr.Number.System.html#known_number_systems/0","title":"Cldr.Number.System.known_number_systems/0","type":"function"},{"doc":"Returns {:ok, digits} for a number system, or an {:error, message} if the number system is not known. Arguments system_name is any number system name returned by Cldr.known_number_systems/0 or a number system type returned by Cldr.known_number_system_types/0 Returns {:ok, string_of_digits} or {:error, {exception, reason}} Examples iex&gt; Cldr.Number.System . number_system_digits ( :latn ) { :ok , &quot;0123456789&quot; } iex&gt; Cldr.Number.System . number_system_digits ( :nope ) { :error , { Cldr.UnknownNumberSystemError , &quot;The number system :nope is not known or does not have digits&quot; } }","ref":"Cldr.Number.System.html#number_system_digits/1","title":"Cldr.Number.System.number_system_digits/1","type":"function"},{"doc":"Returns digits for a number system, or raises an exception if the number system is not know. Arguments system_name is any number system name returned by Cldr.known_number_systems/0 or a number system type returned by Cldr.known_number_system_types/0 Returns A string of the number systems digits or raises an exception Examples iex&gt; Cldr.Number.System . number_system_digits! :latn &quot;0123456789&quot; Cldr.Number.System . number_system_digits! :nope ** (Cldr.UnknownNumberSystemError) The number system :nope is not known or does not have digits","ref":"Cldr.Number.System.html#number_system_digits!/1","title":"Cldr.Number.System.number_system_digits!/1","type":"function"},{"doc":"Returns the actual number system from a number system type. Arguments locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 system_name is any number system name returned by Cldr.known_number_systems/0 or a number system type returned by Cldr.known_number_system_types/0 backend is any Cldr backend. That is, any module that contains use Cldr Returns {:ok, number_system_map} or {:error, {exception, reason}} Notes This function will decode a number system type into the actual number system. If the number system provided can't be decoded it is returned as is. Examples iex&gt; Cldr.Number.System . number_system_for &quot;th&quot; , :latn , TestBackend.Cldr { :ok , %{ digits : &quot;0123456789&quot; , type : :numeric } } iex&gt; Cldr.Number.System . number_system_for &quot;en&quot; , :default , TestBackend.Cldr { :ok , %{ digits : &quot;0123456789&quot; , type : :numeric } } iex&gt; Cldr.Number.System . number_system_for &quot;he&quot; , :traditional , TestBackend.Cldr { :ok , %{ rules : &quot;hebrew&quot; , type : :algorithmic } } iex&gt; Cldr.Number.System . number_system_for &quot;en&quot; , :finance , TestBackend.Cldr { :error , { Cldr.UnknownNumberSystemError , &quot;The number system :finance is unknown for the locale named \\&quot; en \\&quot; . Valid number systems are %{default: :latn, native: :latn}&quot; } } iex&gt; Cldr.Number.System . number_system_for &quot;en&quot; , :native , TestBackend.Cldr { :ok , %{ digits : &quot;0123456789&quot; , type : :numeric } }","ref":"Cldr.Number.System.html#number_system_for/3","title":"Cldr.Number.System.number_system_for/3","type":"function"},{"doc":"Returns the number system from a language tag or locale name. Arguments locale is any language tag returned be Cldr.Locale.new/2 Returns A number system name as an atom Examples iex&gt; { :ok , locale } = MyApp.Cldr . validate_locale ( &quot;en-US-u-nu-thai&quot; ) iex&gt; Cldr.Number.System . number_system_from_locale ( locale ) :thai iex&gt; { :ok , locale } = MyApp.Cldr . validate_locale ( &quot;en-US&quot; ) iex&gt; Cldr.Number.System . number_system_from_locale locale :latn iex&gt; Cldr.Number.System . number_system_from_locale ( &quot;ar&quot; ) :arab","ref":"Cldr.Number.System.html#number_system_from_locale/1","title":"Cldr.Number.System.number_system_from_locale/1","type":"function"},{"doc":"Returns the default number system from a language tag or locale name. Arguments locale is any language tag returned be Cldr.Locale.new/2 or a locale name in the list returned by Cldr.known_locale_names/1 backend is any Cldr backend. That is, any module that contains use Cldr Returns A number system name as an atom Examples iex&gt; Cldr.Number.System . number_system_from_locale &quot;en-US-u-nu-thai&quot; , MyApp.Cldr :thai iex&gt; Cldr.Number.System . number_system_from_locale &quot;en-US&quot; , MyApp.Cldr :latn","ref":"Cldr.Number.System.html#number_system_from_locale/2","title":"Cldr.Number.System.number_system_from_locale/2","type":"function"},{"doc":"Returns the names of the number systems available for a locale or an {:error, message} tuple if the locale is not known. Arguments locale is any locale returned by Cldr.Locale.new!/2 or a Cldr.LanguageTag struct backend is any Cldr backend. That is, any module that contains use Cldr Examples iex&gt; Cldr.Number.System . number_system_names_for ( &quot;en&quot; , TestBackend.Cldr ) { :ok , [ :latn ] } iex&gt; Cldr.Number.System . number_system_names_for ( &quot;th&quot; , TestBackend.Cldr ) { :ok , [ :latn , :thai ] } iex&gt; Cldr.Number.System . number_system_names_for ( &quot;he&quot; , TestBackend.Cldr ) { :ok , [ :latn , :hebr ] } iex&gt; Cldr.Number.System . number_system_names_for ( &quot;zz&quot; , TestBackend.Cldr ) { :error , { Cldr.InvalidLanguageError , &quot;The language \\&quot; zz \\&quot; is invalid&quot; } }","ref":"Cldr.Number.System.html#number_system_names_for/2","title":"Cldr.Number.System.number_system_names_for/2","type":"function"},{"doc":"Returns the names of the number systems available for a locale or an {:error, message} tuple if the locale is not known. Arguments locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 backend is any Cldr backend. That is, any module that contains use Cldr Examples iex&gt; Cldr.Number.System . number_system_names_for! ( &quot;en&quot; , TestBackend.Cldr ) [ :latn ] iex&gt; Cldr.Number.System . number_system_names_for! ( &quot;th&quot; , TestBackend.Cldr ) [ :latn , :thai ] iex&gt; Cldr.Number.System . number_system_names_for! ( &quot;he&quot; , TestBackend.Cldr ) [ :latn , :hebr ]","ref":"Cldr.Number.System.html#number_system_names_for!/2","title":"Cldr.Number.System.number_system_names_for!/2","type":"function"},{"doc":"Return a map of all CLDR number systems and definitions. Example iex&gt; Cldr.Number.System . number_systems |&gt; Enum . count 86","ref":"Cldr.Number.System.html#number_systems/0","title":"Cldr.Number.System.number_systems/0","type":"function"},{"doc":"Returns the number systems available for a locale or {:error, message} if the locale is not known. Arguments locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 backend is any Cldr backend. That is, any module that contains use Cldr Examples iex&gt; Cldr.Number.System . number_systems_for &quot;en&quot; { :ok , %{ default : :latn , native : :latn } } iex&gt; Cldr.Number.System . number_systems_for &quot;th&quot; { :ok , %{ default : :latn , native : :thai } } iex&gt; Cldr.Number.System . number_systems_for &quot;zz&quot; , TestBackend.Cldr { :error , { Cldr.UnknownLocaleError , &quot;The locale \\&quot; zz \\&quot; is not known.&quot; } }","ref":"Cldr.Number.System.html#number_systems_for/2","title":"Cldr.Number.System.number_systems_for/2","type":"function"},{"doc":"Returns the number systems available for a locale or raises if the locale is not known. Arguments locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 backend is any Cldr backend. That is, any module that contains use Cldr . The default is Cldr.default_backend!/0 . Examples iex&gt; Cldr.Number.System . number_systems_for! &quot;en&quot; %{ default : :latn , native : :latn } iex&gt; Cldr.Number.System . number_systems_for! &quot;th&quot; , TestBackend.Cldr %{ default : :latn , native : :thai }","ref":"Cldr.Number.System.html#number_systems_for!/2","title":"Cldr.Number.System.number_systems_for!/2","type":"function"},{"doc":"Returns locale and number systems that have the same digits and separators as the supplied one. Arguments locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 system_name is any number system name returned by Cldr.known_number_systems/0 or a number system type returned by Cldr.known_number_system_types/0 backend is any Cldr backend. That is, any module that contains use Cldr Returns Notes Transliterating between locale &amp; number systems is expensive. To avoid unncessary transliteration we look for locale and number systems that have the same digits and separators. Typically we are comparing to locale &quot;en&quot; and number system &quot;latn&quot; since this is what the number formatting routines use as placeholders. Examples","ref":"Cldr.Number.System.html#number_systems_like/3","title":"Cldr.Number.System.number_systems_like/3","type":"function"},{"doc":"Returns a number system name for a given locale and number system reference. Arguments system_name is any number system name returned by Cldr.known_number_systems/0 or a number system type returned by Cldr.known_number_system_types/0 locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 backend is any Cldr backend. That is, any module that contains use Cldr Notes Number systems can be references in one of two ways: As a number system type such as :default, :native, :traditional and :finance. This allows references to a number system for a locale in a consistent fashion for a given use WIth the number system name directly, such as :latn, :arab or any of the other 70 or so This function dereferences the supplied system_name and returns the actual system name. Examples ex &gt; Cldr.Number.System . system_name_from ( :default , &quot;en&quot; , TestBackend.Cldr ) { :ok , :latn } iex&gt; Cldr.Number.System . system_name_from ( &quot;latn&quot; , &quot;en&quot; , TestBackend.Cldr ) { :ok , :latn } iex&gt; Cldr.Number.System . system_name_from ( :native , &quot;en&quot; , TestBackend.Cldr ) { :ok , :latn } iex&gt; Cldr.Number.System . system_name_from ( :nope , &quot;en&quot; , TestBackend.Cldr ) { :error , { Cldr.UnknownNumberSystemError , &quot;The number system :nope is unknown&quot; } } Note that return value is not guaranteed to be a valid number system for the given locale as demonstrated in the third example.","ref":"Cldr.Number.System.html#system_name_from/3","title":"Cldr.Number.System.system_name_from/3","type":"function"},{"doc":"Returns a number system name for a given locale and number system reference and raises if the number system is not available for the given locale. Arguments system_name is any number system name returned by Cldr.known_number_systems/0 or a number system type returned by Cldr.known_number_system_types/0 locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 backend is any Cldr backend. That is, any module that contains use Cldr Examples iex&gt; Cldr.Number.System . system_name_from! ( :default , &quot;en&quot; , TestBackend.Cldr ) :latn iex&gt; Cldr.Number.System . system_name_from! ( &quot;latn&quot; , &quot;en&quot; , TestBackend.Cldr ) :latn iex&gt; Cldr.Number.System . system_name_from! ( :traditional , &quot;he&quot; , TestBackend.Cldr ) :hebr","ref":"Cldr.Number.System.html#system_name_from!/3","title":"Cldr.Number.System.system_name_from!/3","type":"function"},{"doc":"Number systems that have their own digit characters defined.","ref":"Cldr.Number.System.html#systems_with_digits/0","title":"Cldr.Number.System.systems_with_digits/0","type":"function"},{"doc":"Converts a number into the representation of a non-latin number system. This function converts numbers to a known number system only, it does not provide number formatting. Arguments number is a float , integer or Decimal system_name is any number system name returned by Cldr.known_number_systems/0 or a number system type returned by Cldr.known_number_system_types/0 backend is any Cldr backend. That is, any module that contains use Cldr Returns {:ok, string_of_digits} or {:error, {exception, reason}} Notes There are two types of number systems in CLDR: :numeric in which the number system defines a direct mapping between the latin digits 0..9 into a the number system equivalent. In this case, to_system/3 invokes Cldr.Number.Transliterate.transliterate_digits/3 for the given number. :algorithmic in which the number system does not have the same structure as the :latn number system and therefore the conversion is done algorithmically. For CLDR the algorithm is implemented through Cldr.Rbnf rulesets. These rulesets are considered by CLDR to be less rigorous than the :numeric number systems and caution and testing for a specific use case is recommended. Examples iex&gt; Cldr.Number.System . to_system 123456 , :hebr , TestBackend.Cldr { :ok , &quot;קכ״ג׳תנ״ו&quot; } iex&gt; Cldr.Number.System . to_system 123 , :hans , TestBackend.Cldr { :ok , &quot;一百二十三&quot; } iex&gt; Cldr.Number.System . to_system 123 , :hant , TestBackend.Cldr { :ok , &quot;一百二十三&quot; } iex&gt; Cldr.Number.System . to_system 123 , :hansfin , TestBackend.Cldr { :ok , &quot;壹佰贰拾叁&quot; }","ref":"Cldr.Number.System.html#to_system/3","title":"Cldr.Number.System.to_system/3","type":"function"},{"doc":"Converts a number into the representation of a non-latin number system. Returns a converted string or raises on error. Arguments number is a float , integer or Decimal system_name is any number system name returned by Cldr.known_number_systems/0 or a number system type returned by Cldr.known_number_system_types/0 backend is any Cldr backend. That is, any module that contains use Cldr Returns string_of_digits or raises an exception See Cldr.Number.System.to_system/3 for further information. Examples iex&gt; Cldr.Number.System . to_system! 123 , :hans , TestBackend.Cldr &quot;一百二十三&quot; iex&gt; Cldr.Number.System . to_system! 123 , :hant , TestBackend.Cldr &quot;一百二十三&quot; iex&gt; Cldr.Number.System . to_system! 123 , :hansfin , TestBackend.Cldr &quot;壹佰贰拾叁&quot;","ref":"Cldr.Number.System.html#to_system!/3","title":"Cldr.Number.System.to_system!/3","type":"function"},{"doc":"Returns an error tuple for an number system unknown to a given locale. Arguements number_system is any number system name not returned by Cldr.known_number_systems/0 locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 valid_number_systems is a map returned by Cldr.Number.System.number_systems_for/2","ref":"Cldr.Number.System.html#unknown_number_system_for_locale_error/3","title":"Cldr.Number.System.unknown_number_system_for_locale_error/3","type":"function"},{"doc":"","ref":"Cldr.Number.System.html#t:system_name/0","title":"Cldr.Number.System.system_name/0","type":"type"},{"doc":"","ref":"Cldr.Number.System.html#t:types/0","title":"Cldr.Number.System.types/0","type":"type"},{"doc":"Transliteration for digits and separators. Transliterating a string is an expensive business. First the string has to be exploded into its component graphemes. Then for each grapheme we have to map to the equivalent in the other {locale, number_system} . Then we have to reassemble the string. Effort is made to short circuit where possible. Transliteration is not required for any {locale, number_system} that is the same as {&quot;en&quot;, &quot;latn&quot;} since the implementation uses this combination for the placeholders during formatting already. When short circuiting is possible (typically the en-* locales with &quot;latn&quot; number_system - the total number of short circuited locales is 211 of the 537 in CLDR) the overall number formatting is twice as fast than when formal transliteration is required. Configuring precompilation of digit transliterations This module includes Cldr.Number.Transliterate.transliterate_digits/3 which transliterates digits between number systems. For example from :arabic to :latn. Since generating a transliteration map is slow, pairs of transliterations can be configured so that the transliteration map is created at compile time and therefore speeding up transliteration at run time. To configure these transliteration pairs, add the following to your backend configuration: defmodule MyApp.Cldr do use Cldr , locale : [ &quot;en&quot; , &quot;fr&quot; , &quot;th&quot; ] , default_locale : &quot;en&quot; , precompile_transliterations : [ { :latn , :thai } , { :arab , :thai } ] end Where each tuple in the list configures one transliteration map. In this example, two maps are configured: from :latn to :thai and from :arab to :thai. A list of configurable number systems is returned by Cldr.Number.System.systems_with_digits/0 . If a transliteration is requested between two number pairs that have not been configured for precompilation, a warning is logged.","ref":"Cldr.Number.Transliterate.html","title":"Cldr.Number.Transliterate","type":"module"},{"doc":"Transliterates from latin digits to another number system's digits. Transliterates the latin digits 0..9 to their equivalents in another number system. Also transliterates the decimal and grouping separators as well as the plus, minus and exponent symbols. Any other character in the string will be returned &quot;as is&quot;. sequence is the string to be transliterated. locale is any known locale, defaulting to Cldr.get_locale/0 . number_system is any known number system. If expressed as a string it is the actual name of a known number system. If epressed as an atom it is used as a key to look up a number system for the locale (the usual keys are :default and :native but :traditional and :finance are also part of the standard). See Cldr.Number.System.number_systems_for/2 for a locale to see what number system types are defined. The default is :default . For available number systems see Cldr.Number.System.number_systems/0 and Cldr.Number.System.number_systems_for/2 . Also see Cldr.Number.Symbol.number_symbols_for/2 . Examples iex&gt; Cldr.Number.Transliterate . transliterate ( &quot;123556&quot; , &quot;en&quot; , :default , TestBackend.Cldr ) &quot;123556&quot; iex&gt; Cldr.Number.Transliterate . transliterate ( &quot;123,556.000&quot; , &quot;fr&quot; , :default , TestBackend.Cldr ) &quot;123 556,000&quot; iex&gt; Cldr.Number.Transliterate . transliterate ( &quot;123556&quot; , &quot;th&quot; , :default , TestBackend.Cldr ) &quot;123556&quot; iex&gt; Cldr.Number.Transliterate . transliterate ( &quot;123556&quot; , &quot;th&quot; , &quot;thai&quot; , TestBackend.Cldr ) &quot;๑๒๓๕๕๖&quot; iex&gt; Cldr.Number.Transliterate . transliterate ( &quot;123556&quot; , &quot;th&quot; , :native , TestBackend.Cldr ) &quot;๑๒๓๕๕๖&quot; iex&gt; Cldr.Number.Transliterate . transliterate ( &quot;Some number is: 123556&quot; , &quot;th&quot; , &quot;thai&quot; , TestBackend.Cldr ) &quot;Some number is: ๑๒๓๕๕๖&quot;","ref":"Cldr.Number.Transliterate.html#transliterate/4","title":"Cldr.Number.Transliterate.transliterate/4","type":"function"},{"doc":"","ref":"Cldr.Number.Transliterate.html#transliterate_digits/3","title":"Cldr.Number.Transliterate.transliterate_digits/3","type":"function"},{"doc":"Functions to implement Rules Based Number Formatting (rbnf) During compilation RBNF rules are extracted and generated as function bodies by Cldr.Rbnf.Ordinal , Cldr.Rbnf.Cardinal and Cldr.Rbnf.NumberSystem . The functions in this module would not normally be of common use outside of supporting the compilation phase.","ref":"Cldr.Rbnf.html","title":"Cldr.Rbnf","type":"module"},{"doc":"Returns {:ok, rbnf_rules} for a locale or {:error, {Cldr.NoRbnf, info}} locale is any t:Cldr.LanguageTag This function reads the raw locale definition and therefore should not be called at runtime.","ref":"Cldr.Rbnf.html#for_locale/1","title":"Cldr.Rbnf.for_locale/1","type":"function"},{"doc":"Returns {:ok, rbnf_rules} for a locale or {:error, {Cldr.NoRbnf, info}} locale is any locale name returned by Cldr.Rbnf.known_locale_names/1 backend is any module that includes use Cldr and therefore is a Cldr backend module","ref":"Cldr.Rbnf.html#for_locale/2","title":"Cldr.Rbnf.for_locale/2","type":"function"},{"doc":"Returns rbnf_rules for a locale or raises an exception if there are no rules. locale is any Cldr.LanguageTag backend is any module that includes use Cldr and therefore is a Cldr backend module","ref":"Cldr.Rbnf.html#for_locale!/1","title":"Cldr.Rbnf.for_locale!/1","type":"function"},{"doc":"Returns rbnf_rules for a locale and backend or raises an exception if there are no rules. locale is any locale name returned by Cldr.Rbnf.known_locale_names/1 backend is any module that includes use Cldr and therefore is a Cldr backend module","ref":"Cldr.Rbnf.html#for_locale!/2","title":"Cldr.Rbnf.for_locale!/2","type":"function"},{"doc":"Returns the list of locales that that have RBNF defined This list is the set of known locales for which there are rbnf rules defined. Delegates to Cldr.known_rbnf_locale_names/1","ref":"Cldr.Rbnf.html#known_locale_names/1","title":"Cldr.Rbnf.known_locale_names/1","type":"function"},{"doc":"","ref":"Cldr.Rbnf.html#rbnf_locale_error/1","title":"Cldr.Rbnf.rbnf_locale_error/1","type":"function"},{"doc":"","ref":"Cldr.Rbnf.html#rbnf_rule_error/2","title":"Cldr.Rbnf.rbnf_rule_error/2","type":"function"},{"doc":"Returns the list of RBNF rules for a locale. A rule name can be used as the :format parameter in Cldr.Number.to_string/3 . Arguments locale is any Cldr.LanguageTag.t() Returns {:ok, [list_of_rule_names_as_atoms]} or {:error, {exception, reason}} Examples iex&gt; Cldr.Rbnf . rule_names_for_locale &quot;zh&quot; { :ok , [ :spellout_cardinal_alternate2 , :spellout_ordinal , :spellout_cardinal , :spellout_cardinal_financial , :spellout_numbering , :spellout_numbering_days , :spellout_numbering_year , :digits_ordinal ] } iex&gt; Cldr.Rbnf . rule_names_for_locale &quot;fp&quot; { :error , { Cldr.InvalidLanguageError , &quot;The language &quot; fp &quot; is invalid&quot; } }","ref":"Cldr.Rbnf.html#rule_names_for_locale/1","title":"Cldr.Rbnf.rule_names_for_locale/1","type":"function"},{"doc":"","ref":"Cldr.Rbnf.html#rule_names_for_locale/2","title":"Cldr.Rbnf.rule_names_for_locale/2","type":"function"},{"doc":"Returns the list of RBNF rules for a locale. A rule name can be used as the :format parameter in Cldr.Number.to_string/3 . Arguments locale is any Cldr.LanguageTag.t() Returns [list_of_rule_names_as_atoms] , or raises an exception Examples iex&gt; Cldr.Rbnf . rule_names_for_locale! &quot;zh&quot; [ :spellout_cardinal_alternate2 , :spellout_ordinal , :spellout_cardinal , :spellout_cardinal_financial , :spellout_numbering , :spellout_numbering_days , :spellout_numbering_year , :digits_ordinal ]","ref":"Cldr.Rbnf.html#rule_names_for_locale!/1","title":"Cldr.Rbnf.rule_names_for_locale!/1","type":"function"},{"doc":"Macro to define the interpreter for the compiled RBNF rules specific to a rule group (Ordinal, Spellout, NumberingSystem)","ref":"Cldr.Rbnf.Processor.html","title":"Cldr.Rbnf.Processor","type":"module"},{"doc":"","ref":"Cldr.Rbnf.Processor.html#define_rules/3","title":"Cldr.Rbnf.Processor.define_rules/3","type":"function"},{"doc":"","ref":"Cldr.Rbnf.Processor.html#rbnf_rule_error/3","title":"Cldr.Rbnf.Processor.rbnf_rule_error/3","type":"function"},{"doc":"Tokenizer and Parser for RBNF rules.","ref":"Cldr.Rbnf.Rule.html","title":"Cldr.Rbnf.Rule","type":"module"},{"doc":"Parse an RBNF rule definition Returns a list of rule subparts that can then be used for further processing or for turning into an AST for execution.","ref":"Cldr.Rbnf.Rule.html#parse/1","title":"Cldr.Rbnf.Rule.parse/1","type":"function"},{"doc":"Scan and tokenize rule definition Using a leex lexer, tokenize a rule definition","ref":"Cldr.Rbnf.Rule.html#tokenize/1","title":"Cldr.Rbnf.Rule.tokenize/1","type":"function"},{"doc":"Exception raised when an attempt is made to define a currency that already exists.","ref":"Cldr.CurrencyAlreadyDefined.html","title":"Cldr.CurrencyAlreadyDefined","type":"exception"},{"doc":"Exception raised when an attempt is made to define a currency code that is invalid.","ref":"Cldr.CurrencyCodeInvalid.html","title":"Cldr.CurrencyCodeInvalid","type":"exception"},{"doc":"Exception raised when when there are no number symbols for a locale and number system.","ref":"Cldr.NoNumberSymbols.html","title":"Cldr.NoNumberSymbols","type":"exception"},{"doc":"Exception raised when when trying to parse a string into a number and the string is not parseable.","ref":"Cldr.Number.ParseError.html","title":"Cldr.Number.ParseError","type":"exception"},{"doc":"Exception raised when an attempt is made to invoke an RBNF rule that is not supported for a given locale","ref":"Cldr.Rbnf.NoRule.html","title":"Cldr.Rbnf.NoRule","type":"exception"},{"doc":"Exception raised when an attempt is made to invoke an RBNF rule for a number that is not supported by that rule.","ref":"Cldr.Rbnf.NoRuleForNumber.html","title":"Cldr.Rbnf.NoRuleForNumber","type":"exception"},{"doc":"","ref":"readme.html","title":"Number and Currency Localization and Formatting","type":"extras"},{"doc":"ex_cldr_numbers is an addon library application for ex_cldr that provides localization and formatting for numbers and currencies. In order to use this library, a backend module for ex_cldr must be defined. This is described in full in the ex_cldr readme . To get started, define a backend module in your project as follows: defmodule MyApp.Cldr do use Cldr , locales : [ &quot;en&quot; , &quot;fr&quot; , &quot;zh&quot; ] , providers : [ Cldr.Number ] end The following examples assume the existence of this module. The primary api is MyApp.Cldr.Number.to_string/2 . The following examples demonstrate: iex&gt; MyApp.Cldr.Number . to_string 12345 { :ok , &quot;12,345&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , locale : &quot;fr&quot; { :ok , &quot;12 345&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , locale : &quot;fr&quot; , currency : &quot;USD&quot; { :ok , &quot;12 345,00 $US&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , locale : &quot;en&quot; , currency : &quot;USD&quot; , currency_symbol : :iso { :ok , &quot;USD 12,345.00&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , format : &quot;#E0&quot; { :ok , &quot;1.2345E4&quot; } For help in iex : iex&gt; h MyApp.Cldr.Number . to_string","ref":"readme.html#introduction-and-getting-started","title":"Number and Currency Localization and Formatting - Introduction and Getting Started","type":"extras"},{"doc":"Unicode technical report TR35 states that for scientific formats (i.e. mantissa and exponent): The maximum number of integer digits, if present, specifies the exponent grouping. The most common use of this is to generate engineering notation, in which the exponent is a multiple of three, for example, &quot;##0.###E0&quot;. The number 12345 is formatted using &quot;##0.####E0&quot; as &quot;12.345E3&quot;. ex_cldr_numbers does not currently support this functionality.","ref":"readme.html#known-restrictions-and-limitations","title":"Number and Currency Localization and Formatting - Known restrictions and limitations","type":"extras"},{"doc":"Note that ex_cldr_numbers requires Elixir 1.10 or later. Add ex_cldr_numbers as a dependency to your mix project: defp deps do [ { :ex_cldr_numbers , &quot;~&gt; 2.0&quot; } ] end then retrieve ex_cldr_numbers from hex : mix deps . get mix deps . compile","ref":"readme.html#installation","title":"Number and Currency Localization and Formatting - Installation","type":"extras"},{"doc":"ex_cldr_numbers uses the configuration set for the dependency ex_cldr . See the documentation for ex_cldr","ref":"readme.html#configuration","title":"Number and Currency Localization and Formatting - Configuration","type":"extras"},{"doc":"CLDR defines many different ways to format a number for different uses and defines a set of formats categorised by common pupose to make it easier to express the same intent across many different locales that represent many different territories, cultures, number systems and scripts. See MyApp.Cldr.Number , MyApp.Cldr.Number.to_string/2 and Cldr.Number.to_number_system/3 . Primary Public API The primary api for number formatting is MyApp.Cldr.Number.to_string/2 . It provides the ability to format numbers in a standard way for configured locales. It also provides the means for format numbers as a currency, as a short form (like 1k instead of 1,000). Additionally it provides formats to spell a number in words, format it as roman numerals and output an ordinal number. Some examples illustrate: iex&gt; MyApp.Cldr.Number . to_string 12345 { :ok , &quot;12,345&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , locale : &quot;fr&quot; { :ok , &quot;12 345&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , locale : &quot;fr&quot; , currency : &quot;USD&quot; { :ok , &quot;12 345,00 $US&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , format : &quot;#E0&quot; { :ok , &quot;1.2345E4&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , format : :accounting , currency : &quot;THB&quot; { :ok , &quot;THB12,345.00&quot; } iex&gt; MyApp.Cldr.Number . to_string - 12345 , format : :accounting , currency : &quot;THB&quot; { :ok , &quot;(THB12,345.00)&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , format : :accounting , currency : &quot;THB&quot; , locale : &quot;th&quot; { :ok , &quot;THB12,345.00&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , format : :accounting , currency : &quot;THB&quot; , locale : &quot;th&quot; , number_system : :native { :ok , &quot;THB๑๒,๓๔๕.๐๐&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , maximum_integer_digits : 2 { :ok , &quot;45&quot; } iex&gt; MyApp.Cldr.Number . to_string 1244.30 , format : :long { :ok , &quot;1 thousand&quot; } iex&gt; MyApp.Cldr.Number . to_string 1244.30 , format : :long , currency : &quot;USD&quot; { :ok , &quot;1,244.30 US dollars&quot; } iex&gt; MyApp.Cldr.Number . to_string 1244.30 , format : :short { :ok , &quot;1K&quot; } iex&gt; MyApp.Cldr.Number . to_string 1244.30 , format : :short , currency : &quot;EUR&quot; { :ok , &quot;€1.24K&quot; } iex&gt; MyApp.Cldr.Number . to_string 1234 , format : :spellout { :ok , &quot;one thousand two hundred thirty-four&quot; } iex&gt; MyApp.Cldr.Number . to_string 1234 , format : :spellout_verbose { :ok , &quot;one thousand two hundred and thirty-four&quot; } iex&gt; MyApp.Cldr.Number . to_string 123 , format : :ordinal { :ok , &quot;123rd&quot; } iex&gt; MyApp.Cldr.Number . to_string 123 , format : :roman { :ok , &quot;CXXIII&quot; } iex&gt; MyApp.Number . to_string 123 , locale : &quot;th-u-nu-thai&quot; { :ok , &quot;๑๒๓&quot; } iex&gt; MyApp.Number . to_string 123 , format : :currency , locale : &quot;en-u-cu-thb&quot; { :ok , &quot;THB 123.00&quot; } Standard Formatting Styles Cldr supports the styles of formatting defined by CLDR being: :standard which formats a number if a decimal format commonly used in many locales. This is the default format. iex&gt; MyApp.Cldr.Number . to_string 1234 , format : :standard { :ok , &quot;1,234&quot; } :currency which formats a number according to the format or a particular currency adjusted for rounding, number of decimal digits after the fraction, whether the currency is accounting or cash rounded and using the appropriate locale-specific currency symbol. This format also requires that the option :currency be specified. Note that for currency formatting the defined rounding and fractional digits defined for the currency is used. The parameter :currency_digits can also be specified to indicate if formatting is to use :accounting , :cash or :iso digit definitions. The default is :accounting . Some currencies, like the Swiss Franc and Australian Dollar have a smallest cash amount that is 0.05 of the Franc of Dollar and hence rounding has to take that into account. When a currency format is requested, the option :currency_symbol may also be set to :iso . In this case the ISO currency code will be used instead of the currency symbol. iex&gt; MyApp.Cldr.Number . to_string 1234.31 , format : :currency , currency : :CHF { :ok , &quot;CHF1,234.31&quot; } iex&gt; MyApp.Cldr.Number . to_string 1234.31 , format : :currency , currency : :CHF , currency_digits : :cash { :ok , &quot;CHF1,234.30&quot; } :accounting which formats a positive number like :standard but which usually wraps a negative number in () . The :accounting format also requires that the :currency option be specified. iex&gt; MyApp.Cldr.Number . to_string 1234 , format : :accounting , currency : :THB { :ok , &quot;THB1,234.00&quot; } iex&gt; MyApp.Cldr.Number . to_string - 1234 , format : :accounting , currency : :THB { :ok , &quot;(THB1,234.00)&quot; } :percent which multiplies a number by 100 and includes a locale-specific percent symbol which is usually % . iex&gt; MyApp.Cldr.Number . to_string 0.09 , format : :percent { :ok , &quot;9%&quot; } :permille (aka 'basis points') which multiples a number by 1,000 and includes a locale specific permille symbol which is usually ‰ . Note that many (most?) locales don't provide a :permille format definition. The alternative is to specify a format string as in the example below. iex&gt; MyApp.Cldr.Number . to_string 0.56 , format : &quot;#‰&quot; { :ok , &quot;560‰&quot; } iex&gt; MyApp.Cldr.Number . to_string 0.56 , format : :permille { :error , { MyApp.Cldr.UnknownFormatError , &quot;The locale \\&quot; en \\&quot; with number system :default does not define a format :permille.&quot; } } :scientific which formats a number as a mantissa and base-10 exponent. iex&gt; MyApp.Cldr.Number . to_string 124.56 , format : :scientific { :ok , &quot;1.2456E2&quot; } See MyApp.Cldr.Number.Formatter.Decimal . Short and Long Formats Cldr also supports formats that minimise publishing space or which attempt to make large numbers more human-readable. :short which presents a number or currency in a narrow space. iex&gt; MyApp.Cldr.Number . to_string 12456.56 , format : :short { :ok , &quot;12K&quot; } iex&gt; MyApp.Cldr.Number . to_string 12456.56 , format : :short , currency : :USD { :ok , &quot;$12K&quot; } :long which presents numbers in a sentence form adjusted for plurality and locale. For example, 1,0000 would be formatted as 1 thousand . This is not the same as spelling out the number which is part of the Unicode CLDR Rules-Based Number Formatting. See MyApp.Cldr.Rbnf . iex&gt; MyApp.Cldr.Number . to_string 12456.56 , format : :long { :ok , &quot;12 thousand&quot; } iex&gt; MyApp.Cldr.Number . to_string 1 , format : :long , currency : :USD { :ok , &quot;1 US dollar&quot; } iex&gt; MyApp.Cldr.Number . to_string 12456.56 , format : :long , currency : :USD { :ok , &quot;12,457 US dollars&quot; } See MyApp.Cldr.Number.Formatter.Short and MyApp.Cldr.Number.Formatter.Currency . Locale extensions affecting formatting A locale identifier can specify options that affect number formatting. These options are: cu : defines what currency is implied when no currency is specified in the call to to_string/2 . cf : defines whether to use currency or accounting format for formatting currencies. This overrides the format: :currency and format: :accounting options. nu : defines the number system to be used if no :number_system option to to_string/2 is provided. These keys are part of the u extension and that document should be consulted for details on how to construct a locale identifier with these extensions. The following examples illustrate: iex&gt; MyApp.Number . to_string 123 , locale : &quot;th-u-nu-thai&quot; { :ok , &quot;๑๒๓&quot; } iex&gt; MyApp.Number . to_string 123 , format : :currency , locale : &quot;en-u-cu-thb&quot; { :ok , &quot;THB 123.00&quot; } User-Specified Number Formats User-defined decimal formats are also supported using the formats described by Unicode technical report TR35 . The formats described therein are supported by ex_cldr_numbers with some minor omissions and variations. Some examples of number formats are: Pattern Currency Text #,##0.## n/a 1 234,57 #,##0.### n/a 1 234,567 ###0.##### n/a 1234,567 ###0.0000# n/a 1234,5670 00000.0000 n/a 01234,5670 00 n/a 12 #,##0.00 ¤ EUR 1 234,57 € See MyApp.Cldr.Number and MyApp.Cldr.Number.Formatter.Decimal . Number Pattern Character Definitions The folllowing table describes the symbols used in a number format string and is extracted from TR35 Symbol Location Localized Replacement Meaning 0 Number digit Digit 1 .. 9 Number digit '1' through '9' indicate rounding @ Number digit Significant digit # Number digit, nothing Digit, omit leading/trailing zeros . Number decimal symbol Decimal or monetary decimal separator - Number minus sign Minus sign&lt;sup&gt;[1]&lt;/sup&gt; , Number grouping separator Decimal/monetary grouping separator&lt;sup&gt;[2]&lt;/sup E Number exponent Separates mantissa and exponent for scientific formatting + Exponent plus sign Prefix positive exponent with plus sign % Pre/Suffix percent sign Multiply by 100 and show as a percentage ‰ Pre/Suffix per mille Multiply by 1000 and show as per mille (aka “basis points”) ; Subpattern syntax only Separates positive and negative subpatterns ¤ Pre/Suffix currency symbol Currency symbol&lt;sup&gt;[3]&lt;/sup&gt; * Pre/Suffix padding character Pad escape, precedes padding character ' Pre/Suffix syntax only To quote special chars. eg '#' Notes &lt;sup&gt;[1]&lt;/sup&gt; The pattern '-'0.0 is not the same as the pattern -0.0 . In the former case, the minus sign is a literal. In the latter case, it is a special symbol, which is replaced by the localised minus symbol, and can also be replaced by the plus symbol for a format like +12%. &lt;sup&gt;[2]&lt;/sup&gt; May occur in both the integer part and the fractional part. The position determines the grouping. &lt;sup&gt;[3]&lt;/sup&gt; Any sequence is replaced by the localized currency symbol for the currency being formatted, as in the table below. If present in a pattern, the monetary decimal separator and grouping separators (if available) are used instead of the numeric ones. If data is unavailable for a given sequence in a given locale, the display may fall back to ¤ or ¤¤ . No. Replacement Example ¤ Standard currency symbol as in C$12.00 ¤¤ ISO currency symbol as in CAD 12.00 ¤¤¤ Appropriate currency display name based upon locale and plural rules ¤¤¤¤ Narrow currency symbol as in $12.00 Rule Based Number Formats CLDR provides an additional mechanism for the formatting of numbers. This approach can be used to format numbers in locale-specific words, or to format numbers in a number system that does not use the decimal digits 0 through 9 such as Chinese and Hebrew. Formatting numbers as words, ordinals and roman numerals As words. For example, formatting 123 into &quot;one hundred and twenty-three&quot; for the &quot;en&quot; locale. The applicable format types are :spellout and :spellout_verbose . iex&gt; MyApp.Cldr.Number . to_string 123 , format : :spellout { :ok , &quot;one hundred twenty-three&quot; } iex&gt; MyApp.Cldr.Number . to_string 123 , format : :spellout_verbose { :ok , &quot;one hundred and twenty-three&quot; } As a year. In many languages the written form of a year is different to that used for an arbitrary number. For example, formatting 1989 would result in &quot;nineteen eighty-nine&quot;. The applicable format type is :spellout_year . iex&gt; MyApp.Cldr.Number . to_string 2017 , format : :spellout_year { :ok , &quot;twenty seventeen&quot; } As an ordinal. For example, formatting 123 into &quot;123rd&quot;. The applicable format types are :ordinal , :spellout_ordinal and :spellout_ordinal_verbose . iex&gt; MyApp.Cldr.Number . to_string 123 , format : :ordinal { :ok , &quot;123rd&quot; } iex&gt; MyApp.Cldr.Number . to_string 123 , format : :spellout_ordinal { :ok , &quot;one hundred twenty-third&quot; } iex&gt; MyApp.Cldr.Number . to_string 123 , format : :spellout_ordinal_verbose { :ok , &quot;one hundred and twenty-third&quot; } iex&gt; MyApp.Cldr.Number . to_string 123 , format : :ordinal , locale : &quot;fr&quot; { :ok , &quot;123e&quot; } iex&gt; MyApp.Cldr.Number . to_string 123 , format : :ordinal , locale : &quot;zh&quot; { :ok , &quot;第123&quot; } As Roman numerals. For example, formatting 123 into &quot;CXXIII&quot;. The applicable formats are :roman or :roman_lower . Note that roman number formatting is only supported for numbers between 1 and 5,000. iex&gt; MyApp.Cldr.Number . to_string 123 , format : :roman { :ok , &quot;CXXIII&quot; } iex&gt; MyApp.Cldr.Number . to_string 123 , format : :roman_lower { :ok , &quot;cxxiii&quot; } iex&gt; MyApp.Cldr.Number . to_string 12345 , format : :roman_lower { :ok , &quot;12,345&quot; } Converting numbers to non-latin number systems Some number systems, such as Hebrew and Chinese, do not use the digits 0 through 9 in the their native number system. RBNF defines rules for these and other number systems that can provide number system conversion. MyApp.Cldr.Number.to_string/2 does not support number systems without digits defined therefore another mechanism is required to output numbers in these algorithmic number systems. To support number system conversion, the function Cldr.Number.to_number_system/3 is provided. Note that no formatting is supported, this is a number system conversion only. For example, to output a number in the :hans numbering system (Chinese) and the Hebrew number system: iex&gt; Cldr.Number . to_number_system 123 , :hans , MyApp.Cldr { :ok , &quot;一百二十三&quot; } iex&gt; Cldr.Number . to_number_system 123 , :hebr , MyApp.Cldr { :ok , &quot;ק׳&quot; } Cldr.Number.to_number_system/3 supports the conversion between numeric number systems (those with digits 0 through 9) in addition to algorithmic number systems (those supported by rules-based number formatting). For example, outputting to the :thai number system: iex&gt; Cldr.Number . to_number_system 123 , :thai , MyApp.Cldr { :ok , &quot;๑๒๓&quot; } The known number systems in Cldr can be returned by the function Cldr.Number.System.known_number_systems/0 : iex&gt; Cldr.Number.System . known_number_systems [ :adlm , :ahom , :arab , :arabext , :armn , :armnlow , :bali , :beng , :bhks , :brah , :cakm , :cham , :cyrl , :deva , :ethi , :fullwide , :geor , :grek , :greklow , :gujr , :guru , :hanidays , :hanidec , :hans , :hansfin , :hant , :hantfin , :hebr , :hmng , :java , :jpan , :jpanfin , :kali , :khmr , :knda , :lana , :lanatham , :laoo , :latn , :lepc , :limb , :mathbold , :mathdbl , :mathmono , :mathsanb , :mathsans , :mlym , :modi , :mong , :mroo , ... ] RBNF rules defined in CLDR There are also many additional methods more specialised to a specific locale that cater for languages with more complex gender and grammar requirements. Since these rules are specialised to a locale it is not possible to standarise the public API more than described in this section. The full set of RBNF formats is accessable through the modules MyApp.Cldr.Rbnf.Ordinal , MyApp.Cldr.Rbnf.Spellout and MyApp.Cldr.Rbnf.NumberSystem . Each of these modules has a set of functions that are generated at compile time that implement the relevant RBNF rules. The available rules for a given locale can be retrieved by calling MyApp.Cldr.Rbnf.Spellout.rule_set(locale) or the same function on the other modules. For example: iex&gt; MyApp.Cldr.Rbnf.Ordinal . rule_sets &quot;en&quot; [ :digits_ordinal ] iex&gt; MyApp.Cldr.Rbnf.Spellout . rule_sets &quot;fr&quot; [ :spellout_ordinal_masculine_plural , :spellout_ordinal_masculine , :spellout_ordinal_feminine_plural , :spellout_ordinal_feminine , :spellout_numbering_year , :spellout_numbering , :spellout_cardinal_masculine , :spellout_cardinal_feminine ] These rule-based formats are invoked directly on the required module passing the number and locale. For example: iex&gt; MyApp.Cldr.Rbnf.Spellout . spellout_numbering_year 1989 , &quot;fr&quot; &quot;dix-neuf-cent quatre-vingt-neuf&quot; iex&gt; MyApp.Cldr.Rbnf.Spellout . spellout_numbering_year 1989 , &quot;en&quot; &quot;nineteen eighty-nine&quot; iex&gt; MyApp.Cldr.Rbnf.Ordinal . digits_ordinal 1989 , &quot;en&quot; &quot;1,989th&quot; RBNF Rules with Float numbers RBNF is primarily oriented towards positive integer numbers. Whilst the standard caters for negative numbers and fractional numbers the implementation of the rules is incomplete. Use with care.","ref":"readme.html#formatting-numbers","title":"Number and Currency Localization and Formatting - Formatting Numbers","type":"extras"},{"doc":"Cldr.Number.Parser provides two functions to support the parsing of localised number strings into numbers. Cldr.Number.Parser.parse/2 assumes the string is a number only. Cldr.Number.Parser.scan/2 will attempt to extract numbers from an arbitrary string. In all cases, the locale-specific number separators are permitted providing a reliable way to extract locale-specific numbers from a string. Examples iex&gt; Cldr.Number.Parser . parse ( &quot;＋1.000,34&quot; , locale : &quot;de&quot; ) { :ok , 1000.34 } iex&gt; Cldr.Number.Parser . parse ( &quot;-1_000_000.34&quot; ) { :ok , - 1000000.34 } iex&gt; Cldr.Number.Parser . parse ( &quot;1.000&quot; , locale : &quot;de&quot; , number : :integer ) { :ok , 1000 } iex&gt; Cldr.Number.Parser . parse ( &quot;＋1.000,34&quot; , locale : &quot;de&quot; , number : :integer ) { :error , &quot;＋1.000,34&quot; } iex&gt; Cldr.Number.Parser . scan ( &quot;£1_000_000.34&quot; ) [ &quot;£&quot; , 1000000.34 ] iex&gt; Cldr.Number.Parser . scan ( &quot;I want £1_000_000 dollars&quot; ) [ &quot;I want £&quot; , 1000000 , &quot; dollars&quot; ] iex&gt; Cldr.Number.Parser . scan ( &quot;The prize is 23&quot; ) [ &quot;The prize is &quot; , 23 ] iex&gt; Cldr.Number.Parser . scan ( &quot;The lottery number is 23 for the next draw&quot; ) [ &quot;The lottery number is &quot; , 23 , &quot; for the next draw&quot; ] iex&gt; Cldr.Number.Parser . scan ( &quot;The loss is -1.000 euros&quot; , locale : &quot;de&quot; , number : :integer ) [ &quot;The loss is &quot; , - 1000 , &quot; euros&quot; ]","ref":"readme.html#parsing-numbers-from-a-string","title":"Number and Currency Localization and Formatting - Parsing Numbers from a string","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is the changelog for Cldr v2.23.3 released on December 14th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes short formatting for decimal numbers. Thanks to @datrader for the report. Closes #135.","ref":"changelog.html#cldr_numbers-v2-23-3","title":"Changelog - Cldr_Numbers v2.23.3","type":"extras"},{"doc":"This is the changelog for Cldr v2.23.2 released on December 3rd, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes Cldr.Number.Parser.resolve_currencies/1 when the argument is whitespace only. Thanks to @datrader for the report.","ref":"changelog.html#cldr_numbers-v2-23-2","title":"Changelog - Cldr_Numbers v2.23.2","type":"extras"},{"doc":"This is the changelog for Cldr v2.23.1 released on December 1st, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Replace use Mix.Config with import Config in config files Fix typespec for &lt;backend&gt;.Cldr.Number.Transliterate.transliterate_digits/3","ref":"changelog.html#cldr_numbers-v2-23-1","title":"Changelog - Cldr_Numbers v2.23.1","type":"extras"},{"doc":"This is the changelog for Cldr v2.23.0 released on October 27th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Updates to support CLDR release 40 via ex_cldr version 2.24 Adds Cldr.Rbnf.rule_names_for_locale/1 to return the available RBNF rule names for a given locale. Bug Fixes Arbitrary RBNF rule lookup falls back to the root locale (called &quot;und&quot;) when checking if a rule is available. Thanks to @maennchen for the report. Closes #22. Fixes performance issue when calling Cldr.Number.to_string/3 with an arbitrary RBNF rule name. Previously these formats would mistakenly read the raw json file for a locale incurring a significant performance penaly. Performance is now 100x faster as expected. Thanks to @maennchen for the bug report. Closes #21. Deprecations Don't call deprecated Cldr.Config.known_locale_names/1 , call Cldr.Locale.Loader.known_locale_names/1 instead. Don't call deprecated Cldr.Config.get_locale/2 , use Cldr.Locale.Loader.get_locale/2 instead.","ref":"changelog.html#cldr_numbers-v2-23-0","title":"Changelog - Cldr_Numbers v2.23.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.23.0-rc.4 released on October 26th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Arbitrary RBNF rule lookup falls back to the root locale (called &quot;und&quot;) when checking if a rule is available. Thanks to @maennchen for the report. Closes #22.","ref":"changelog.html#cldr_numbers-v2-23-0-rc-4","title":"Changelog - Cldr_Numbers v2.23.0-rc.4","type":"extras"},{"doc":"This is the changelog for Cldr v2.23.0-rc.3 released on October 25th, 2021. For older changelogs please consult the release tag on GitHub Deprecations Don't call deprecated Cldr.Config.known_locale_names/1 , call Cldr.Locale.Loader.known_locale_names/1 instead.","ref":"changelog.html#cldr_numbers-v2-23-0-rc-3","title":"Changelog - Cldr_Numbers v2.23.0-rc.3","type":"extras"},{"doc":"This is the changelog for Cldr v2.23.0-rc.2 released on October 24th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Don't call deprecated Cldr.Config.get_locale/2 , use Cldr.Locale.Loader.get_locale/2 instead.","ref":"changelog.html#cldr_numbers-v2-23-0-rc-2","title":"Changelog - Cldr_Numbers v2.23.0-rc.2","type":"extras"},{"doc":"This is the changelog for Cldr v2.23.0-rc.1 released on October 24th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Adds Cldr.Rbnf.rule_names_for_locale/1 to return the available RBNF rule names for a given locale. Bug Fixes Fixes performance issue when calling Cldr.Number.to_string/3 with an arbitrary RBNF rule name. Previously these formats would mistakenly read the raw json file for a locale incurring a significant performance penaly. Performance is now 100x faster as expected. Thanks to @maennchen for the bug report. Closes #21.","ref":"changelog.html#cldr_numbers-v2-23-0-rc-1","title":"Changelog - Cldr_Numbers v2.23.0-rc.1","type":"extras"},{"doc":"This is the changelog for Cldr v2.23.0-rc.0 released on October 3rd, 2021. For older changelogs please consult the release tag on GitHub Enhancements Updates to support CLDR release 40","ref":"changelog.html#cldr_numbers-v2-23-0-rc-0","title":"Changelog - Cldr_Numbers v2.23.0-rc.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.22.1 released on September 13th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Return the remainder strings with casing preserved when resolving currencies and pers in Cldr.Numbers.Parser .","ref":"changelog.html#cldr_numbers-v2-22-1","title":"Changelog - Cldr_Numbers v2.22.1","type":"extras"},{"doc":"This is the changelog for Cldr v2.22.0 released on August 22nd, 2021. For older changelogs please consult the release tag on GitHub Enhancements Cldr.Number.Parser.resolve_currencies/2 and Cldr.Number.Parser.resolve_per/2 only perform replacements if the the found string is not adjacent to an alphabetic character. Cldr.Number.Parser.resolve/2 and Cldr.Number.Parser.find_and_replace/2 are made public functions. Add resolve_pers/2 and resolve_per/2 to the MyApp.Number module.","ref":"changelog.html#cldr_numbers-v2-22-0","title":"Changelog - Cldr_Numbers v2.22.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.21.0 released on August 18th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.Number.Parser.resolve_pers/2 which will tokenize percent and permille symbols into :percent and :permille . This is similar to the Cldr.Number.Parser.resolve_currencies/2 function but for percent and permille symbols. An example is: iex&gt; Cldr.Number.Parser . scan ( &quot;100%&quot; ) ...&gt; |&gt; Cldr.Number.Parser . resolve_pers ( ) [ 100 , :percent ]","ref":"changelog.html#cldr_numbers-v2-21-0","title":"Changelog - Cldr_Numbers v2.21.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.20.0 released on August 17th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Improve number parsing with Cldr.Number.Parser.scan/2 when the string has lists of numbers separated by commas. Thanks to @DaTrader for the report. Closes #19. Enhancements Add support for custom currency symbols. This extends the use of the :currency_symbol option. In previousl releases this option was required to be :standard or :iso . Now the value can also be :narrow , :symbol or a string which will be used as the currency symbol. From the documentation for Cldr.Number.to_string/3 : currency_symbol : Allows overriding a currency symbol. The alternatives are: :iso the ISO currency code will be used instead of the default currency symbol. :narrow uses the narrow symbol defined for the locale. The same narrow symbol can be defined for more than one currency and therefore this should be used with care. If no narrow symbol is defined, the standard symbol is used. :symbol uses the standard symbol defined in CLDR. A symbol is unique for each currency and can be safely used. &quot;string&quot; uses string as the currency symbol :standard (the default and recommended) uses the CLDR-defined symbol based upon the currency format for the locale.","ref":"changelog.html#cldr_numbers-v2-20-0","title":"Changelog - Cldr_Numbers v2.20.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.19.0 released on July 1st, 2021. For older changelogs please consult the release tag on GitHub Enhancements Updated to ex_cldr version 2.23.0 which changes the names of some of the field in the &quot;-u-&quot; extension to match the CLDR canonical name. In particular the field name number_system changes to numbers .","ref":"changelog.html#cldr_numbers-v2-19-0","title":"Changelog - Cldr_Numbers v2.19.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.18.4 released on June 17th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Allow t:Cldr.Currency as a :currency option in Cldr.Number.to_string/2 . Thanks to @jeroenvisser101 for the PR.","ref":"changelog.html#cldr_numbers-v2-18-4","title":"Changelog - Cldr_Numbers v2.18.4","type":"extras"},{"doc":"This is the changelog for Cldr v2.18.3 released on June 12th, 2021. For older changelogs please consult the release tag on GitHub Breaking Change There is a minor breaking change in the error return from Cldr.Number.Parser.parse/2 . Previously the error return was {:error, string} . It is now more consistent with the rest of ex_cldr and returns {:error, {exception, message}} Bug Fixes Fix Cldr.Number.Parser.parse/2 for numbers that are in non-latin scripts (like Thai, Arabic, ...). There are 66 known number systems that have decimal digits as of CLDR39.","ref":"changelog.html#cldr_numbers-v2-18-3","title":"Changelog - Cldr_Numbers v2.18.3","type":"extras"},{"doc":"This is the changelog for Cldr v2.18.2 released on June 11th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Fix Cldr.Number.Parser.scan/2 to correctly parse numbers like 1kg","ref":"changelog.html#cldr_numbers-v2-18-2","title":"Changelog - Cldr_Numbers v2.18.2","type":"extras"},{"doc":"This is the changelog for Cldr v2.18.1 released on June 8th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Thanks to @alaadahmed for the collaboration to fix two bugs in rules based number formatting. Fixes RBNF formatting options setting for :spellout_ordinal Allows any defined RNBF rule for a locale to be invoked as the :format option to Cldr.Number.to_string/3 .","ref":"changelog.html#cldr_numbers-v2-18-1","title":"Changelog - Cldr_Numbers v2.18.1","type":"extras"},{"doc":"This is the changelog for Cldr v2.18.0 released on May 8th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes short and long number formatting. Fixes formatting whent the format string consists only of digits. Previously this would erroneously set both the maximum and minimum integer digits. Now it only sets the minimum integer digits. Enhancements Add option :maximum_integer_digits as an option to Cldr.Number.to_string/2","ref":"changelog.html#cldr_numbers-v2-18-0","title":"Changelog - Cldr_Numbers v2.18.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.17.0 released on April 8th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Updated to require ex_cldr version 2.20 which includes CLDR 39 data.","ref":"changelog.html#cldr_numbers-v2-17-0","title":"Changelog - Cldr_Numbers v2.17.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.16.1 released on November 8th, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Fix bug in Cldr.Number.System.number_system_from/1 to correctly allow a binary language tag without a backend parameter (which will then default to Cldr.default_backend!/0 )","ref":"changelog.html#cldr_numbers-v2-16-1","title":"Changelog - Cldr_Numbers v2.16.1","type":"extras"},{"doc":"This is the changelog for Cldr v2.16.0 released on November 1st, 2020. For older changelogs please consult the release tag on GitHub Enhancements Support CLDR 38 Add Cldr.Number.Formatter.Short.short_format_exponent/2 to support compact number pluralization that is added to CLDR 38 (for the &quot;fr&quot; locale only in this release)","ref":"changelog.html#cldr_numbers-v2-16-0","title":"Changelog - Cldr_Numbers v2.16.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.15.4 released on Septmber 26th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Use Cldr.default_backend!/1 when available since Cldr.default_backend/0 is deprecated as of ex_cldr verison 2.18.0 . Bug Fixes Use Cldr.Decimal.compare/2 which works consistently with Decimal 1.x and 2.x Apply compile-time detection of Decimal version in order to know the correct return type of Decimal.parse/1 which differs between 1.x and 2.x","ref":"changelog.html#cldr_numbers-v2-15-4","title":"Changelog - Cldr_Numbers v2.15.4","type":"extras"},{"doc":"This is the changelog for Cldr v2.15.3 released on September 5th, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Fix documentation referencing Cldr.known_locale_names/10 to correctly reference Cldr.known_locale_names/0 .","ref":"changelog.html#cldr_numbers-v2-15-3","title":"Changelog - Cldr_Numbers v2.15.3","type":"extras"},{"doc":"This is the changelog for Cldr v2.15.2 released on August 30th, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Removes dialyzer warning when running on Elixir 1.11. Uses Logger.warning/2 not Logger.warn/2 in this case and uses an anonymous function not a string so that dialyzer is happy.","ref":"changelog.html#cldr_numbers-v2-15-2","title":"Changelog - Cldr_Numbers v2.15.2","type":"extras"},{"doc":"This is the changelog for Cldr v2.15.1 released on June 23rd, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes two number parsing bugs: A bug whereby decimal and separator symbols would be impacted in non-number strings when using MyApp.Cldr.Number.scan/2 A bug whereby numbers using various localised symbols would not be recognised Fix formatter pipeline generation which was including the round nearest pipeline stage even when not required. Thanks to @jeroenvisser101 for the collaboration. Fixes #14.","ref":"changelog.html#cldr_numbers-v2-15-1","title":"Changelog - Cldr_Numbers v2.15.1","type":"extras"},{"doc":"This is the changelog for Cldr v2.15.0 released on June 13th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Support binary locale name as an argument to Cldr.Number.System.number_system_from_locale/2 Add number_system_from_locale/1 to backend modules","ref":"changelog.html#cldr_numbers-v2-15-0","title":"Changelog - Cldr_Numbers v2.15.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.14.0 released on May 27th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.Number.Parser.parse/2 to parse numbers in a locale-aware manner Add Cldr.Number.Parser.scan/2 to parse a string into a list of string and numbers Add Cldr.Number.Parser.resolve_currencies/2 to match strings to currency codes in a list Add Cldr.Number.Parser.resolve_currency/2 to match a string to a currency code","ref":"changelog.html#cldr_numbers-v2-14-0","title":"Changelog - Cldr_Numbers v2.14.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.13.2 released on May 16th, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Fix regression and allow :percent formats in Cldr.Number.to_string/3 . Thanks to @maennchen. Fixes #13.","ref":"changelog.html#cldr_numbers-v2-13-2","title":"Changelog - Cldr_Numbers v2.13.2","type":"extras"},{"doc":"This is the changelog for Cldr v2.13.1 released on May 14th, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Fix regression and allow :fractional_digits to be 0 . Thanks to @coladarci. Fixes #12.","ref":"changelog.html#cldr_numbers-v2-13-1","title":"Changelog - Cldr_Numbers v2.13.1","type":"extras"},{"doc":"This is the changelog for Cldr v2.13.0 released on May 2nd, 2020. For older changelogs please consult the release tag on GitHub Breaking change In previous releases, requesting a currency format in Number.to_string/3 without specifying an option :currency would return an error. In this release, a currency is derived from the locale (either the :locale parameter or from backend.get_locale() ). The affected currency formats are :currency , :accounting , :currency_long and :currency_short Enhancements Cldr.Number.to_string/2 now detects the number system from any supplied locale. If provided, the option :number_system takes precedence over the number system derived from a locale. Add :round_nearest formatting option for Cldr.Number.to_string/3 . If provided, this option overrides the value defined by the :format option. Refines number system detection. The order of precedence is: The :number_system option if provided The :number_system from the locale if provided The :number_system from the current locale for the supplied backend. This locale is retrieved with backend.get_locale()","ref":"changelog.html#cldr_numbers-v2-13-0","title":"Changelog - Cldr_Numbers v2.13.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.12.1 released on March 2nd, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Use the RBNF format spellout_numbering instead of spellout_cardinal for the Cldr.Number.to_string/3 option format: :spellout since spellout_numbering has a larger locale coverage of RBNF formats.","ref":"changelog.html#cldr_numbers-v2-12-1","title":"Changelog - Cldr_Numbers v2.12.1","type":"extras"},{"doc":"This is the changelog for Cldr v2.12.0 released on January 21st, 2020. For older changelogs please consult the release tag on GitHub Enhancements Updates version requirement for cldr_utils in order to support versions of decimal from 1.6 up to 2.0 . Bug fixes Fixes an incorrect typespec on Cldr.Number.Format.format_from_locale_or_options/1 that was causing a dialyzer warning","ref":"changelog.html#cldr_numbers-v2-12-0","title":"Changelog - Cldr_Numbers v2.12.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.11.0 released on January 19th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Uses the number system defined by the locale if it is specified. The number system is defined as part of the U extension . The order of precedence is: :default if no option is provided to MyApp.Cldr.Number.to_string/2 and no number system is defined in the locale The option :number_system if it is provided to MyApp.Cldr.Number.to_string/2 The locale's number_system if it is defined and the option :number_system to MyApp.Cldr.Number.to_string/2 is not provided Examples: # Locale defines a number system and no option :number_system is provided iex&gt; TestBackend.Cldr.Number . to_string ( 1234 , locale : &quot;th-u-nu-thai&quot; ) { :ok , &quot;๑,๒๓๔&quot; } # Locale defines a number system but an option :number_system is also provded which # take precedence iex&gt; MyApp.Cldr.Number . to_string 1234 , locale : &quot;th-u-nu-latn&quot; , number_system : :thai { :ok , &quot;๑,๒๓๔&quot; } # A number system is defined in the locale but it is not supported by the # locale iex&gt; MyApp.Cldr.Number . to_string 1234 , locale : &quot;en-AU-u-nu-thai&quot; { :error , { Cldr.UnknownNumberSystemError , &quot;The number system :thai is unknown for the locale named \\&quot; en \\&quot; . Valid number systems are %{default: :latn, native: :latn}&quot; } } Uses the currency code defined by the locale if it is specified and the number format requested is :currency . The currency code is defined as part of the U extension . The order of precedence is: The option :currency if it is provided to MyApp.Cldr.Number.to_string/2 The locale's currency code if it is defined and the option :currency to MyApp.Cldr.Number.to_string/2 is not provided Examples: # Use the currency code :AUD specified in the locale iex&gt; MyApp.Cldr.Number . to_string 1234 , locale : &quot;en-AU-u-cu-aud&quot; , format : :currency { :ok , &quot;A$1,234.00&quot; } # Use the currency code :USD provided as an option in precedence over the currency code # defined by the locale iex&gt; MyApp.Cldr.Number . to_string 1234 , locale : &quot;en-AU-u-cu-aud&quot; , format : :currency , currency : :USD { :ok , &quot;$1,234.00&quot; } Uses the currency format defined by the locale if it is specified and the number format requested is :currency or :accounting . The currency format is defined as part of the U extension . The order of precedence is: The locale's currency format if it is defined and the option :format to MyApp.Cldr.Number.to_string/2 is either :currency or :accounting . Therefore the locales currency format takes precendence over the :format argument but only if :format is a currency format. The option :format in every other case Examples: # Using in the locale currency format - just happens to be the same as the format option iex&gt; MyApp.Cldr.Number . to_string - 1234 , locale : &quot;en-AU-u-cu-aud-cf-standard&quot; , format : :currency { :ok , &quot;A$-1,234.00&quot; } # The locale format takes precedence over the format option iex&gt; MyApp.Cldr.Number . to_string - 1234 , locale : &quot;en-AU-u-cu-aud-cf-standard&quot; , format : :accounting { :ok , &quot;A$-1,234.00&quot; } iex&gt; MyApp.Cldr.Number . to_string - 1234 , locale : &quot;en-AU-u-cu-aud-cf-account&quot; , format : :accounting { :ok , &quot;(A$1,234.00)&quot; } iex&gt; MyApp.Cldr.Number . to_string - 1234 , locale : &quot;en-AU-u-cu-aud-cf-account&quot; , format : :currency { :ok , &quot;(A$1,234.00)&quot; }","ref":"changelog.html#cldr_numbers-v2-11-0","title":"Changelog - Cldr_Numbers v2.11.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.10.0 released on January 15th, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes formatting of negative percentages. Actually fixes an issue where the default negative format would be incorrect in many cases. Thanks to @maennchen. Closes #11. Enhancements Optionally logs a warning if compiling a number format at runtime. The warning is emitted only once for each format to reduce log clutter. The log warning is emitted if the backend configuration key :supress_warnings is set to false (this is the default value). The warn_once mechanism depends on the availability of the :persistent_term module which is only available from OTP 21.2 onwards. On earlier releases of OTP no warning will be emitted.","ref":"changelog.html#cldr_numbers-v2-10-0","title":"Changelog - Cldr_Numbers v2.10.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.9.0 released on October 20th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Adds option :currency_symbol to Cldr.Number.to_string/2 . This option, when set to :iso changes a currency format to force using the ISO currency code instead of the native currency symbol.","ref":"changelog.html#cldr_numbers-v2-9-0","title":"Changelog - Cldr_Numbers v2.9.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.8.0 released on October 10th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Update ex_cldr to version 2.11.0 which encapsulates CLDR version 36.0.0 data.","ref":"changelog.html#cldr_numbers-v2-8-0","title":"Changelog - Cldr_Numbers v2.8.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.7.2 released on September 7th, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes Call Keyword.get_lazy/3 when accessing Cldr.default_locale/0 to avoid exceptions when no default backend is configured but an optional :backend has been passed.","ref":"changelog.html#cldr_numbers-v2-7-2","title":"Changelog - Cldr_Numbers v2.7.2","type":"extras"},{"doc":"This is the changelog for Cldr v2.7.1 released on August 23rd, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes Fix @spec for Cldr.Number.to_string/3 and Cldr.Number.to_string!/3","ref":"changelog.html#cldr_numbers-v2-7-1","title":"Changelog - Cldr_Numbers v2.7.1","type":"extras"},{"doc":"This is the changelog for Cldr v2.7.0 released on August 21st, 2019. For older changelogs please consult the release tag on GitHub Enhancements An option :backend can be passed to Cldr.Number.to_string/3 and it will be used if being called as Cldr.Number.to_string/2 . This means that for a call like Cldr.Number.to_string(number, backend, options) which has an option :backend , the call can be replaced with Cldr.Number.to_string(number, options) .","ref":"changelog.html#cldr_numbers-v2-7-0","title":"Changelog - Cldr_Numbers v2.7.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.6.4 released on June 16th, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes Fix the default value for the backend parameter for Cldr.Number.to_string/3 Allow Cldr.Number.to_string/3 to be called as Cldr.Number.to_string &lt;number&gt;, &lt;options&gt; as long as there is a default backend configured in config.exs .","ref":"changelog.html#cldr_numbers-v2-6-4","title":"Changelog - Cldr_Numbers v2.6.4","type":"extras"},{"doc":"This is the changelog for Cldr v2.6.3 released on June 15th, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes Correctly interpret the special short format 0 to mean &quot;format as a normal decimal or currency number&quot;. Thanks to @epilgrim. Closes #10","ref":"changelog.html#cldr_numbers-v2-6-3","title":"Changelog - Cldr_Numbers v2.6.3","type":"extras"},{"doc":"This is the changelog for Cldr v2.6.2 released on June 12th, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes Don't transliterate in Cldr.Number.Transliterate.transliterate_digits/3 if from and to number systems are the same.","ref":"changelog.html#cldr_numbers-v2-6-2","title":"Changelog - Cldr_Numbers v2.6.2","type":"extras"},{"doc":"This is the changelog for Cldr v2.6.1 released on June 2nd, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes Ensure Cldr.Number.to_string/3 doesn't transliterate is the number systems are compatible for a given locale. Basically, if the local and number system don't require transliteration from 0..9 to another script (like indian, arabic, ...) then we don't do it. This improves performance by about 10% for this common case.","ref":"changelog.html#cldr_numbers-v2-6-1","title":"Changelog - Cldr_Numbers v2.6.1","type":"extras"},{"doc":"This is the changelog for Cldr v2.6.0 released on March 28th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Updates to CLDR version 35.0.0 released on March 27th 2019.","ref":"changelog.html#cldr_numbers-v2-6-0","title":"Changelog - Cldr_Numbers v2.6.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.5.0 released on March 23rd, 2019. For older changelogs please consult the release tag on GitHub Enhancements Supports Cldr.default_backend() as a default for a backend on functions in Cldr.Number","ref":"changelog.html#cldr_numbers-v2-5-0","title":"Changelog - Cldr_Numbers v2.5.0","type":"extras"},{"doc":"This is the changelog for Cldr v2.4.4 released on March 21st, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes Rbnf.Ordinal and Rbnf.Spellout now respect the optional generation of @moduledocs in a backend","ref":"changelog.html#cldr_numbers-v2-4-4","title":"Changelog - Cldr_Numbers v2.4.4","type":"extras"},{"doc":"This is the changelog for Cldr v2.4.3 released on March 20th, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes Fix dialyzer warnings","ref":"changelog.html#cldr_numbers-v2-4-3","title":"Changelog - Cldr_Numbers v2.4.3","type":"extras"},{"doc":"This is the changelog for Cldr v2.4.2 released on March 15th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Makes generation of documentation for backend modules optional. This is implemented by the :generate_docs option to the backend configuration. The default is true . For example: defmodule MyApp.Cldr do use Cldr , default_locale : &quot;en-001&quot; , locales : [ &quot;en&quot; , &quot;ja&quot; ] , gettext : MyApp.Gettext , generate_docs : false end","ref":"changelog.html#cldr_numbers-v2-4-2","title":"Changelog - Cldr_Numbers v2.4.2","type":"extras"},{"doc":"This is the changelog for Cldr v2.4.1 released on March 7th, 2019. For older changelogs please consult the release tag on GitHub","ref":"changelog.html#cldr_numbers-v2-4-1","title":"Changelog - Cldr_Numbers v2.4.1","type":"extras"},{"doc":"Fix fractional grouping. Previously when there was no grouping, the group size was being set to the number of fractional digits. Fix scientific precision. Previously the mantissa was not being rounded because the prioritisation of significant digits over exponent digits was not being correctly reconciled. Fix formatting precision of an exponent. A format of 0E00 will now format the exponent with two digits. Fix o silence dialyzer warnings","ref":"changelog.html#bug-fixes","title":"Changelog - Bug Fixes","type":"extras"},{"doc":"This is the changelog for Cldr v2.4.0 released on March 4th, 2019. For older changelogs please consult the release tag on GitHub","ref":"changelog.html#cldr_numbers-v2-4-0","title":"Changelog - Cldr_Numbers v2.4.0","type":"extras"},{"doc":"Adds Cldr.Number.Format.default_grouping_for/2 to return the default grouping of digits for a locale. This is useful for external number formats like ex_cldr_print .","ref":"changelog.html#enhancements","title":"Changelog - Enhancements","type":"extras"},{"doc":"This is the changelog for Cldr v2.3.0 released on March 1st, 2019. For older changelogs please consult the release tag on GitHub","ref":"changelog.html#cldr_numbers-v2-3-0","title":"Changelog - Cldr_Numbers v2.3.0","type":"extras"},{"doc":"Opens up the formatting pipeline for use by other formatting systems like printf . This is implemented by the introduction of Cldr.Number.Format.Meta to create the abstract metadata struct. This struct is used for Cldr.Number.to_string/3 and is now available for use by other libraries. The function Cldr.Number.Formatter.Decimal.to_string/3 is the primary function that should be used by other libraries.","ref":"changelog.html#enhancements","title":"Changelog - Enhancements","type":"extras"},{"doc":"This is the changelog for Cldr v2.2.0 released on Febriuary 24th, 2019. For older changelogs please consult the release tag on GitHub","ref":"changelog.html#cldr_numbers-v2-2-0","title":"Changelog - Cldr_Numbers v2.2.0","type":"extras"},{"doc":"Fix generating an error tuple when the number system is a binary Fix @doc errors","ref":"changelog.html#bug-fixes","title":"Changelog - Bug Fixes","type":"extras"},{"doc":"Adds Cldr.Number.Symbol.all_decimal_symbols/1 and Cldr.Number.Symbol.all_grouping_symbols/1 that support parsing of numbers. The symbols are returned as a list. Adds Cldr.Number.Symbol.all_decimal_symbols_class/1 and Cldr.Number.Symbol.all_grouping_symbols_class/1 . The symbols are returned as a String.t which can then be used to define a character class when building a regex.","ref":"changelog.html#enhancements","title":"Changelog - Enhancements","type":"extras"},{"doc":"This is the changelog for Cldr v2.1.1 released on February 3rd, 2019. For older changelogs please consult the release tag on GitHub","ref":"changelog.html#cldr_numbers-v2-1-1","title":"Changelog - Cldr_Numbers v2.1.1","type":"extras"},{"doc":"Formats Decimal.new(&quot;-0&quot;) the same as Decimal.new(&quot;0&quot;) which is to say without the sign. Although the Decimal standard upon which the Decimal library is based allows for -0 , formatting this as a string with the sign is not consistent with the output for integers and floats. Consistency is, in this case, considered to be the correct approach. Fix documentation errors","ref":"changelog.html#bug-fixes","title":"Changelog - Bug Fixes","type":"extras"},{"doc":"This is the changelog for Cldr v2.1.0 released on December 1st, 2018. For older changelogs please consult the release tag on GitHub","ref":"changelog.html#cldr_numbers-v2-1-0","title":"Changelog - Cldr_Numbers v2.1.0","type":"extras"},{"doc":"Added Cldr.Number.to_at_least_string/3 , Cldr.Number.to_at_most_string/3 , Cldr.Number.to_range_string/3 and Cldr.Number.to_approx_string/3 to format numbers in way that conveys the relevant intent. These functions are also defined one each backend. For example, in the &quot;en&quot; locale: iex&gt; MyApp.Cldr.Number . to_at_least_string 1234 { :ok , &quot;1,234+&quot; } iex&gt; MyApp.Cldr.Number . to_at_most_string 1234 { :ok , &quot;≤1,234&quot; } iex&gt; MyApp.Cldr.Number . to_approx_string 1234 { :ok , &quot;~1,234&quot; } iex&gt; MyApp.Cldr.Number . to_range_string 1234 .. 5678 { :ok , &quot;1,234–5,678&quot; } Refactored options for Cldr.Numbers.to_string/3 and other functions that use the common number formatting options structure. Options are now parsed and contained in a Cldr.Number.Format.Options struct. A user-visible benefit is that if passing a Cldr.Number.Format.Options struct to Cldr.Number.to_string/3 then no further validation or normalization will be performed. Therefore if you are formatting in a tight loop and using common options, saving the options in advance will yield some performance improvement. A Cldr.Number.Format.Options struct can be returned by called Cldr.Number.Format.Options.validate_options(backend, options) .","ref":"changelog.html#enhancements","title":"Changelog - Enhancements","type":"extras"},{"doc":"This is the changelog for Cldr v2.0.0 released on November 22nd, 2018. For older changelogs please consult the release tag on GitHub","ref":"changelog.html#cldr_numbers-v2-0-0","title":"Changelog - Cldr_Numbers v2.0.0","type":"extras"},{"doc":"ex_cldr_numbers now depends upon ex_cldr version 2.0 . As a result it is a requirement that at least one backend module be configured as described in the ex_cldr readme . The public API is now based upon functions defined on a backend module. Therefore calls to functions such as Cldr.Number.to_string/2 should be replaced with calls to MyApp.Cldr.Number.to_string/2 (assuming your configured backend module is called MyApp.Cldr ). Enhancements Adds Cldr.Number.validate_number_system/3 and &lt;backend&gt;.Number.validate_number_system/2 that are now the canonical way to validate and return a number system from either a number system binary or atom, or from a number system name. Cldr.Number.{Ordinal, Cardinal}.pluralize/3 now support ranges, not just numbers Currency spacing is now applied for currency formatting. Depending on the locale, some text may be placed between the current symbol and the number. This enhanced readibility, it does not change the number formatting itself. For example you can see below that for the locale &quot;en&quot;, when the currency symbol is text, a non-breaking space is introduced between it and the number. iex&gt; MyApp.Cldr.Number . to_string 2345 , currency : :USD , format : &quot;¤#,##0.00&quot; { :ok , &quot;$2,345.00&quot; } iex&gt; MyApp.Cldr.Number . to_string 2345 , currency : :USD , format : &quot;¤¤#,##0.00&quot; { :ok , &quot;USD 2,345.00&quot; }","ref":"changelog.html#breaking-changes","title":"Changelog - Breaking Changes","type":"extras"},{"doc":"","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Copyright 2017 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html#license","title":"LICENSE - License","type":"extras"}]